using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using Vha.Vtk.Common;
using Vha.Vtk.Kernel.Common;
using CrystalDecisions.CrystalReports.Engine;
using CrystalDecisions.Shared;
using VTK.Utility;
using Vha.Vtk.WebControlLibrary;
using System.Text;

namespace VTK.FileMaintenance
{
	/// <summary>
	/// Summary description for DonationPrint.
	/// </summary>
	public class DonationPrint : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label ErrorMessage;
		protected System.Web.UI.WebControls.Label DonorLabel;
		protected System.Web.UI.WebControls.RadioButtonList FormList;
		protected System.Web.UI.WebControls.RadioButtonList PrintFormatList;
		protected System.Web.UI.WebControls.Button PrintButton;
		protected Vha.Vtk.WebControlLibrary.VtkPageHeader VtkPageHeader1;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			try
			{
				if (VtkPageHeader1.IsDivSelected("Add|Edit Donation"))
				{
					if (!Page.IsPostBack)
					{
						Page.RegisterHiddenField("Action", String.Empty);
						//check for input parameter, must have or error
						if (Page.Request.QueryString["donationId"] == null)
						{
							VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Donations, Please Exit and try again") ;
							ViewState["donationId"] = null ;
						}
						else
						{
							ViewState["donationId"] = Page.Request.QueryString["donationId"].ToString() ;
							DonorLabel.Text = Page.Request.QueryString["donorName"].ToString() ;
						}
					}

					//save the stationId and donationId on the form
					Page.RegisterHiddenField("StationId", VtkPageHeader1.DivSelectedId.ToString()) ;
					Page.RegisterHiddenField("donationId", ViewState["donationId"].ToString()) ;
				}
				else
				{ Response.Redirect("/Vtk/Welcome.aspx?" + VtkPageHeader.GetURLParameterString()+"=" + VtkPageHeader1.DivSelectedId) ;}
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Donations: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Donations: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Donations: " + err.Message) ;}
		}
		
		private void PrintButton_Click(object sender, System.EventArgs e)
		{
			UIReportParams rp = new UIReportParams();

			rp.AT_InputId=Convert.ToInt32(ViewState["donationId"].ToString());

			// report type
			if (FormList.SelectedItem.Value == "Receipt")
			{ rp.ReportType=UIReportType.VtkSL_DonationReceipt2815FromEdit;}
			else
			{ rp.ReportType=UIReportType.VtkSL_DonationReceiptFromEdit;}

			// report format
			rp.ReportFormat=RptUtility.GetUIReportFormat(PrintFormatList.SelectedItem.Value);

			// Put UIParams into Context
			Context.Items["ReportParams"]=rp;


			// transfer
			if (rp.ReportFormat==UIReportFormat.Web) 
			{
				Server.Transfer(RptUtility.GetCrystalWebTransferString(rp.ReportType, VtkPageHeader1, Request.ApplicationPath));
			} 
			else 
			{
				Server.Transfer("../RptCR/CrystalExport.aspx");
			}
		}

		public class UIReportParams : VTK.Utility.UIReportParams 
		{
			public int AT_InputId;

			public UIReportParams() 
			{
				AT_InputId=0;
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.PrintButton.Click += new System.EventHandler(this.PrintButton_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

	}
}
