using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Text;
using Vha.Vtk.WebControlLibrary;
using VTK.Utility;

namespace VTK.FileMaintenance
{
	/// <summary>
	/// Summary description for PrintMealTicket.
	/// </summary>
	public class PrintMealTicket : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Literal ticket;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			string reprint = Request.QueryString["Reprint"] ;
			int mealId = Convert.ToInt32(Request.QueryString["MealId"].ToString()) ;
			string price = string.Format("{0:F2}", Convert.ToDecimal(Request.QueryString["Price"])) ;

			Vha.Vtk.MealTickets.MealsProvided mthdl = new Vha.Vtk.MealTickets.MealsProvided(mealId, VtkUtility.GetAppCon()) ;
			int numberOfMeals = mthdl.NumberOfMeals ;

			StringBuilder MealTicket = new StringBuilder();

			for (int i=0; i<numberOfMeals; i++)
			{
				MealTicket.Append("\n");
				MealTicket.Append("\n****       *****\n");
				MealTicket.Append(" ****     *******  VOLUNTEER\n");
				MealTicket.Append("  ****   **** ****   MEAL\n");
				MealTicket.Append("   **** ****   **** TICKET\n");
				MealTicket.Append("    ******* ********\n");
				MealTicket.Append("     ***** **********\n\n");
				    
				MealTicket.Append(Request.QueryString["Name"] + "\n\n");
				    
				MealTicket.Append("Date: " + DateTime.Now.ToShortDateString() + "\n\n");
				    
				MealTicket.Append("   NOT VALID FOR \n");
				MealTicket.Append("  MORE THAN $" + price + "\n\n");

				MealTicket.Append("         ^\n");
				MealTicket.Append("        /|\\\n\n");
				        
				MealTicket.Append("____________________________\n");
				MealTicket.Append("Signature Of Volunteer\n");
				MealTicket.Append("         |\n");
				MealTicket.Append("         I\n");
				MealTicket.Append("         M\n");
				MealTicket.Append("         P\n");
				MealTicket.Append("         R\n");
				MealTicket.Append("         I\n");
				MealTicket.Append("VA FORM 10-3558\n");
				MealTicket.Append("         N\n");
				MealTicket.Append("For use by Voluntary \n");
				MealTicket.Append("    Service ONLY\n");
				MealTicket.Append("         T\n");
				if (reprint == "true")
				{ MealTicket.Append("     REPRINTED\n") ;}
				MealTicket.Append("\n");
				MealTicket.Append("\n");
			}

			ticket.Text = MealTicket.ToString();

			//file data into MealTicket table
			mthdl.TimeLastPrinted = DateTime.Now ;
			mthdl.IsReprinted = Convert.ToBoolean(reprint) ;

			mthdl.Save() ;
			mthdl.Dispose() ;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}

