using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Text.RegularExpressions;

using Vha.Vtk;
using Vha.Vtk.Common;
using Vha.Vtk.Kernel.Common;
using Vha.Vtk.Kernel.Data;
using Vha.Vtk.Kernel.Data.SystemTables;
using Vha.Vtk.WebControlLibrary;
using Vha.Vss.Utility;
using Vha.Vtk.TimeKeeping;
using Vha.Vtk.Games;
using GamesLib = Vha.Vtk.Games;

using VTK.Utility;
using VTK.Volunteer;

namespace VTK.Games
{
	/// <summary>
	/// Summary description for GamesRegistration.
	/// </summary>
	public class GamesRegistration : System.Web.UI.Page
	{
		protected Vha.Vtk.WebControlLibrary.VtkPageHeader VtkPageHeader1;
		protected System.Web.UI.WebControls.Label ConfirmationMessage;
		protected System.Web.UI.WebControls.Label ErrorMessage;
		protected Panel GamesListPanel;
		protected Panel VolunteerRegistrationPanel;
		protected System.Web.UI.WebControls.DataGrid GamesList;
		protected System.Web.UI.WebControls.Panel GameVolunteersPanel;
		protected System.Web.UI.WebControls.Button NewButton;
		protected System.Web.UI.WebControls.DataGrid ComboGrid;
		protected System.Web.UI.WebControls.Button PostButton;
		protected System.Web.UI.WebControls.CheckBox InactiveCheckBox;
		protected System.Web.UI.WebControls.DropDownList ServiceList;
		protected System.Web.UI.WebControls.DropDownList WorkdayList;
		protected System.Web.UI.WebControls.DropDownList OrganizationList;
		protected System.Web.UI.WebControls.Label CodeLabel;
		protected System.Web.UI.WebControls.Label VolunteerNameLabel;
		protected System.Web.UI.WebControls.CheckBox FirstTimeCheck;
		protected System.Web.UI.WebControls.DropDownList ShirtSizeList;
		protected System.Web.UI.WebControls.CheckBox RideNeedCheck;
		protected System.Web.UI.WebControls.TextBox RiderLocationText;
		protected System.Web.UI.WebControls.DataGrid GameVolunteersGrid;
		protected System.Web.UI.WebControls.Label NoVolunteerLabel;
		protected System.Web.UI.WebControls.Panel VolunteerChooserPanel;
		protected System.Web.UI.WebControls.Button AddButton;
		protected System.Web.UI.WebControls.Button ChooseButton;
		protected System.Web.UI.WebControls.ListBox VolunteerList;
		protected System.Web.UI.WebControls.Label MatchLabel;
		protected System.Web.UI.WebControls.Button SubmitButton;
		protected System.Web.UI.WebControls.RegularExpressionValidator SSNValidator2;
		protected System.Web.UI.WebControls.TextBox SSNText;
		protected System.Web.UI.WebControls.TextBox NameText;
		protected System.Web.UI.WebControls.TextBox LodgingCodeText;
		protected System.Web.UI.WebControls.ImageButton Previous;
		protected System.Web.UI.WebControls.ImageButton Next;
		protected System.Web.UI.WebControls.ImageButton FIRST;
		protected System.Web.UI.WebControls.ImageButton LAST;
		protected System.Web.UI.WebControls.TextBox SearchText;
		protected System.Web.UI.WebControls.Button SearchButton;
		protected System.Web.UI.WebControls.Panel PagerPanel;
		protected System.Web.UI.WebControls.Panel SearchPanel;
		protected System.Web.UI.WebControls.DropDownList SearchOptionList;
		protected System.Web.UI.WebControls.Button ResetButton;
		protected System.Web.UI.WebControls.Button FinishButton;
		protected System.Web.UI.WebControls.Label EmployeeStatusLabel;
		protected System.Web.UI.WebControls.DropDownList EmployeeStatusList;
		protected System.Web.UI.WebControls.Label RiderLocationLabel;
		protected System.Web.UI.WebControls.Label RiderLocationAstrix;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator1;
		protected System.Web.UI.WebControls.ImageButton GO;
		protected System.Web.UI.WebControls.Label PageCount;
		protected System.Web.UI.WebControls.TextBox CurrentPage;
		protected System.Web.UI.WebControls.Button CancelButton;

		const string emptyText="Enter info above and press 'Search for Existing Volunteers'";

		private void Page_Load(object sender, System.EventArgs e)
		{
			try
			{
				if (VtkPageHeader1.IsDivSelected("Registration")) 
				{
					bool gotGame = false ;
					string volId = string.Empty ;
					string volStId = string.Empty ;
					if(!Page.IsPostBack)
					{
						//return from GamesVolunteerNewEdit
						if (Page.Request.QueryString.Count > 1)
						{
							if (Page.Request.QueryString["GameId"] != null)
							{
								//these inputs come from query strings
								ViewState["GameId"] = Page.Request.QueryString["GameId"].ToString() ;
								gotGame = true ;
							}

							if (Page.Request.QueryString["volId"] != null)
							{
								//these inputs come from query strings
								volId = Page.Request.QueryString["volId"].ToString() ;
							}

							if (Page.Request.QueryString["volName"] != null)
							{
								//these inputs come from query strings
								ViewState["VolunteerName"] = Page.Request.QueryString["volName"].ToString() ;
							}

							if (Page.Request.QueryString["volStId"] != null)
							{
								//these inputs come from query strings
								volStId = Page.Request.QueryString["volStId"].ToString() ;
							}

						}

						if (gotGame && (volId != string.Empty))
						{
							//setup Game info
							DataSet ds = GamesSchedule.GetQuickList(Convert.ToInt32(ViewState["GameId"].ToString())) ;
							DataTable dt = ds.Tables["GamesScheduleList"] ;
							//should only have 1 row
							if(dt.Rows.Count == 1)
							{
								ViewState["HostStationId"]	= dt.Rows[0]["HostStationFk"].ToString() ;
								ViewState["HostStationName"]= dt.Rows[0]["HostInstitutionName"].ToString() ;
								ViewState["GameTypeId"]		= dt.Rows[0]["GameTypeFk"].ToString() ;
								ViewState["GameId"]			= dt.Rows[0]["ID"].ToString() ;
								ViewState["StartDate"]		= dt.Rows[0]["StartDate"].ToString() ;
								ViewState["EndDate"]		= dt.Rows[0]["EndDate"].ToString() ;
								ViewState["GameCode"]		= dt.Rows[0]["Code"].ToString() ;
								//need to add institution to volunteer name, it is the host site
								ViewState["VolunteerName"] = ViewState["VolunteerName"].ToString() + " " + dt.Rows[0]["HostInstitutionName"].ToString() ;

								//setup Game and Volunteer infor
								VolGridUpdate(Convert.ToInt32(ViewState["GameId"].ToString())) ;
								GetServiceList(ViewState["GameCode"].ToString()) ;
								GetVolunteerInfo(Convert.ToInt32(volId), Convert.ToInt32(volStId)) ;
							}
						}
						else
						{							
							try
							{								
								GamesListPanel.Visible = false ;
								GameVolunteersPanel.Visible = true ;
								VolunteerChooserPanel.Visible = false ;
								VolunteerRegistrationPanel.Visible = false ;

								DataSet latestSchedule = GamesSchedule.GetQuickListByInstitutionId(Convert.ToInt32(VtkPageHeader1.DivSelectedId));
								DataTable scheduleDt = latestSchedule.Tables["GamesList"];

								/********************************************************************/
								/*               SAVE THE DATA FROM GAMESLIST PAGE    							*/
								/********************************************************************/
								
								if(scheduleDt.Rows.Count == 1)
								{
									ViewState["HostStationId"]	= scheduleDt.Rows[0]["HostInstitutionId"].ToString() ;
									ViewState["HostStationName"]= scheduleDt.Rows[0]["HostInstitutionName"].ToString() ;
									ViewState["GameTypeId"]		= scheduleDt.Rows[0]["GameTypeId"].ToString() ;
									ViewState["GameId"]			= scheduleDt.Rows[0]["ID"].ToString() ;
									ViewState["StartDate"]		= scheduleDt.Rows[0]["StartDate"].ToString() ;
									ViewState["EndDate"]		= scheduleDt.Rows[0]["EndDate"].ToString() ;
									ViewState["GameCode"]		= scheduleDt.Rows[0]["GameCode"].ToString() ;

									/********************************************************************/
									/*               SETUP FOR VOLUNTEER REGISTRATION INFO							*/
									/********************************************************************/

									VolGridUpdate(Convert.ToInt32(ViewState["GameId"].ToString())) ;
									GetServiceList(ViewState["GameCode"].ToString()) ;
								}
								else if (scheduleDt.Rows.Count > 1)
								{
									GamesListPanel.Visible = true ;
									GameVolunteersPanel.Visible = false ;
									VolunteerChooserPanel.Visible = false ;
									VolunteerRegistrationPanel.Visible = false ;
									GameVolunteersGrid.CurrentPageIndex = 0;
									SetPagerStats();
								}
								else if (scheduleDt.Rows.Count == 0)
								{
									VtkUtility.ErrMsgAdd(ErrorMessage, "You have no permissions for any Games!") ;
									NewButton.Enabled = false ;
								}

							} 
							catch (VhaValidationException valErr)
							{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Games Registration: " + valErr.Message) ;}
							catch (VhaTransactionException transErr)
							{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Games Registration: " + transErr.Message) ;}
							catch (Exception err)
							{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Games Registration: " + err.Message) ;}

							/*
							GamesListPanel.Visible = true ;
							GameVolunteersPanel.Visible = false ;
							VolunteerChooserPanel.Visible = false ;
							VolunteerRegistrationPanel.Visible = false ;
							GameVolunteersGrid.CurrentPageIndex = 0;
							SetPagerStats();
							
							//get games list first
							GamesList.DataSource = GamesSchedule.GetQuickListByInstitutionId(VtkPageHeader1.DivSelectedId);
							GamesList.DataBind();
							*/
						}
						//get other lists
						GetLists() ;
					}
				}
				else
				{ Response.Redirect("/Vtk/Welcome.aspx?" + VtkPageHeader.GetURLParameterString()+"=" + VtkPageHeader1.DivSelectedId) ;}

				//
				Page.RegisterHiddenField("StationId", VtkPageHeader1.DivSelectedId.ToString()) ;
		
			} 
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Games Registration: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Games Registration: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Games Registration: " + err.Message) ;}
		
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.GamesList.EditCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.Register_Click);
			this.SearchButton.Click += new System.EventHandler(this.SearchButton_Click);
			this.ResetButton.Click += new System.EventHandler(this.ResetButton_Click);
			this.GameVolunteersGrid.PageIndexChanged += new System.Web.UI.WebControls.DataGridPageChangedEventHandler(this.PageGrid);
			this.GameVolunteersGrid.EditCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.VolGridEdit_Click);
			this.GameVolunteersGrid.DeleteCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.VolDeleteButton_Click);
			this.FIRST.Click += new System.Web.UI.ImageClickEventHandler(this.Pager_Click);
			this.Previous.Click += new System.Web.UI.ImageClickEventHandler(this.Pager_Click);
			this.GO.Click += new System.Web.UI.ImageClickEventHandler(this.Pager_Click);
			this.Next.Click += new System.Web.UI.ImageClickEventHandler(this.Pager_Click);
			this.LAST.Click += new System.Web.UI.ImageClickEventHandler(this.Pager_Click);
			this.NewButton.Click += new System.EventHandler(this.NewButton_Click);
			this.SubmitButton.Click += new System.EventHandler(this.SubmitButton_Click);
			this.ChooseButton.Click += new System.EventHandler(this.ChooseButton_Click);
			this.AddButton.Click += new System.EventHandler(this.AddButton_Click);
			this.CancelButton.Click += new System.EventHandler(this.FinishButton_Click);
			this.RideNeedCheck.CheckedChanged += new System.EventHandler(this.RideNeedCheck_Click);
			this.PostButton.Click += new System.EventHandler(this.PostButton_Click);
			this.FinishButton.Click += new System.EventHandler(this.FinishButton_Click);
			this.ComboGrid.EditCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.EditCombinationButton_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		#region Section: Private Events

		private void Register_Click(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			try
			{
				
				/********************************************************************/
				/*               SAVE THE DATA FROM GAMESLIST PAGE    							*/
				/********************************************************************/
				ViewState["HostStationId"]	= e.Item.Cells[0].Text;
				ViewState["HostStationName"]= e.Item.Cells[3].Text;
				ViewState["GameTypeId"]		= e.Item.Cells[1].Text;
				ViewState["GameId"]			= e.Item.Cells[2].Text;
				ViewState["StartDate"]		= e.Item.Cells[5].Text;
				ViewState["EndDate"]		= e.Item.Cells[6].Text;
				ViewState["GameCode"]		= e.Item.Cells[7].Text;

				/********************************************************************/
				/*               SETUP FOR VOLUNTEER REGISTRATION INFO							*/
				/********************************************************************/

				VolGridUpdate(Convert.ToInt32(ViewState["GameId"].ToString())) ;
				GetServiceList(ViewState["GameCode"].ToString()) ;
				GamesListPanel.Visible = false ;
				GameVolunteersPanel.Visible = true ;
				VolunteerChooserPanel.Visible = false ;
				VolunteerRegistrationPanel.Visible = false ;

			} 
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Games Registration: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Games Registration: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Games Registration: " + err.Message) ;}
		}

		private void NewButton_Click(object sender, System.EventArgs e)
		{
			//add a new volunteer
			RefreshVolChooser() ;
			NameText.Text = string.Empty ;
			SSNText.Text = string.Empty ;
			ViewState["GameRegId"] = string.Empty ;
			GamesListPanel.Visible = false ;
			GameVolunteersPanel.Visible = false ;
			VolunteerChooserPanel.Visible = true ;
			VolunteerRegistrationPanel.Visible = false ;
		}

		private void SubmitButton_Click(object sender, System.EventArgs e)
		{
			RefreshVolChooser() ;
			//check required fields
			if (SSNText.Text == string.Empty)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "You must enter a Social Security Number") ;}
			else
			{
				if (NameText.Text == String.Empty)
				{VtkUtility.ErrMsgAdd(ErrorMessage, "You must enter the Last Name of the new Volunteer") ;}
				else 
				{
					string ssn = SSNText.Text ;
					string lastName = NameText.Text ;
					string code = lastName.Substring(0,1) + ssn.Substring(5,4) ;
					string name = string.Empty ;
					bool rowCount = false ;
					//if ssn contains dashes, remove
					if (Regex.IsMatch(ssn, @"^\d{3}-\d{2}-\d{4}"))
					{ ssn = ssn.Substring(0,3) + ssn.Substring(4,2) + ssn.Substring(7,4) ;}
					try
					{
						//define columns in list box
						VolunteerList.DataTextField = "DisplayNameWithSSN" ;
						VolunteerList.DataValueField = "IdAndStationId" ;

						//first lookup by SSN
						DataSet dss = Vha.Vtk.TimeKeeping.Volunteer.GetVolunteerListBySSN(ssn) ;
						DataTable dts = dss.Tables["VolunteerList"] ;

						if (dts.Rows.Count > 0)
						{
							rowCount = true ;
							VolunteerList.Enabled = true ;
							ChooseButton.Enabled = true ;
							MatchLabel.Text = "SSN matches the existing voluteer!" ;
							MatchLabel.Visible = true ;
							VolunteerList.Items.Clear();

							//loop thru and build VolDisplay
							foreach (DataRow dr in dts.Rows)
							{
								if (dr["TerminationDate"].ToString() != string.Empty)
								{ dr["DisplayNameWithSSN"] = dr["DisplayNameWithSSN"] + " [TERMINATED]" ;}
							}

							//bind list box to DataTable and dispose
							VolunteerList.DataSource = dts ;
							VolunteerList.DataBind() ;
							//disable add button, they have a ssn match, can't have duplicate ssn
							AddButton.Enabled = false ;
							//if only one volunteer, select it
							if (dts.Rows.Count == 1)
							{ VolunteerList.SelectedIndex = 0 ;}
						}
						else
						{
							//if ssn fails, try lookup by code and check last name
							DataSet dsc = Vha.Vtk.TimeKeeping.Volunteer.GetVolunteerListByIdentifierCode(code, true) ;
							DataTable dtc = dsc.Tables["VolunteerList"] ;

							if (dtc.Rows.Count > 0)
							{
								//loop check last name, if the same then check termination date, else delete
								foreach (DataRow dr in dtc.Rows)
								{
									if (dr["DisplayName"].ToString().StartsWith(lastName))
									{
										if (dr["TerminationDate"].ToString() != null)
										{ dr["DisplayNameWithSSN"] = dr["DisplayNameWithSSN"] + " [TERMINATED]" ;}
										rowCount = true ;
									}
									else
									{ dr.Delete() ;}
								}
							}
							if (rowCount)
							{
								VolunteerList.Enabled = true ;
								ChooseButton.Enabled = true ;
								MatchLabel.Text = "Potential matches of voluteer(s) on last name!" ;
								MatchLabel.Visible = true ;
								VolunteerList.Items.Clear();

								//bind list box to DataTable and dispose
								VolunteerList.DataSource = dtc ;
								VolunteerList.DataBind() ;
								//if only one volunteer, select it
								if (dtc.Rows.Count == 1)
								{ VolunteerList.SelectedIndex = 0 ;}
							}
							else
							{
								MatchLabel.Text = "No volunteers match your criteria!" ;
								MatchLabel.Visible = true ;
							}

							//clean up
							dsc.Dispose() ;
							dtc.Dispose() ;
							//enable add button and get stations
							AddButton.Enabled = true ;
						}
						dss.Dispose() ;
						dts.Dispose() ;
					}
					catch (VhaValidationException valErr)
					{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Volunteer Record: " + valErr.Message) ;}
					catch (VhaTransactionException transErr)
					{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Volunteer Record: " + transErr.Message) ;}
					catch (Exception err)
					{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Volunteer Record: " + err.Message) ;}
				}
			}
		}

		private void ChooseButton_Click(object sender, System.EventArgs e)
		{
			//check to see if they selected a volunteer
			if (VolunteerList.SelectedIndex > -1)
			{
				string volId ;
				int siteId ;
				string[] vsArray ;
				try
				{
					//volId is 'Id&stationId', need to seperate out
					volId = VolunteerList.SelectedItem.Value.ToString() ;
					ViewState["VolunteerName"] = VolunteerList.SelectedItem.Text.ToString() ;
					//vsArray[0] = volId, vsArray[1] = stationId
					vsArray = volId.Split('&') ;
					siteId = Convert.ToInt32(vsArray[1].ToString()) ;
					volId = vsArray[0].ToString() ;
					//check if terminated, it is in the name '(TERMINATED)'
					vsArray = ViewState["VolunteerName"].ToString().Split('[') ;
					//if array has two entries then volunteer was terminated
					if (vsArray.GetLength(0) > 1)
					{
						VtkUtility.ErrMsgAdd(ErrorMessage, "Volunteer has been TERMINATED, No actions allowed") ;
					}
					else
					{
						GetVolunteerInfo(Convert.ToInt32(volId), siteId) ;
					}
				} 
				catch (VhaValidationException valErr)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Volunteer Information: " + valErr.Message) ;}
				catch (VhaTransactionException transErr)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Volunteer Information: " + transErr.Message) ;}
				catch (Exception err)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Volunteer Information: " + err.Message) ;}
			}
			else
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "Please choose a Volunteer from the list before pressing 'Select Existing'") ;}

		}

		private void AddButton_Click(object sender, System.EventArgs e)
		{
			bool comma = false ;
			string fields = string.Empty ;
			string siteId ;
			string gameId ;
			string hostName ;
			//must have name, ssn and station
			if (NameText.Text != String.Empty && (SSNText.Text != string.Empty))
			{
				siteId = ViewState["HostStationId"].ToString() ;
				gameId = ViewState["GameId"].ToString() ;
				hostName = ViewState["HostStationName"].ToString() ;
				//navigate back to GamesVolunteerNewEdit
				StringBuilder sb = new StringBuilder("GamesVolunteerNewEdit.aspx") ;
				//add station of Games
				sb.Append("?StationId=") ;
				sb.Append(VtkPageHeader1.DivSelectedId) ;
				//game Id
				sb.Append("&GameId=") ;
				sb.Append(gameId) ;
				//add Host Name
				sb.Append("&HostName=") ;
				sb.Append(hostName) ;
				//add Host id
				sb.Append("&HostStationId=") ;
				sb.Append(siteId) ;
				//add volunteer name
				sb.Append("&volName=") ;
				sb.Append(NameText.Text) ;
				//add vol station id
				sb.Append("&volSSN=") ;
				sb.Append(SSNText.Text) ;
				Response.Redirect(sb.ToString()) ;
			}
			else
			{
				if (NameText.Text == string.Empty)
				{
					fields = "Last Name" ;
					comma = true ;
				}
				if (SSNText.Text == string.Empty)
				{
					if (comma)
					{ fields = fields + ", " ;}
					fields = fields + "Social Security Number" ;
					comma = true ;
				}
				if (fields != string.Empty)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "The following field(s) are Required to Add a new Volunteer: " + fields) ;}
			}
		}

		private void VolGridEdit_Click(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			string grId ;
			int volId ;
			int siteId ;
			try
			{
				//clean fields and setup to edit registration
				RefreshVolEdit() ;
				GamesListPanel.Visible = false ;
				GameVolunteersPanel.Visible = false ;
				VolunteerChooserPanel.Visible = false ;
				VolunteerRegistrationPanel.Visible = true ;

				//get information from grid
				grId = e.Item.Cells[0].Text.ToString() ;
				ViewState["VolunteerName"] = e.Item.Cells[5].Text.ToString() ;
				ViewState["VolunteerId"] = e.Item.Cells[1].Text.ToString() ;
				ViewState["VolStationId"] = e.Item.Cells[2].Text.ToString() ;
				volId = Convert.ToInt32(ViewState["VolunteerId"].ToString()) ;
				siteId = Convert.ToInt32(ViewState["VolStationId"].ToString()) ;


				//update registration fields, combo codes in grid, and organization list
				SetGameRegInfo(Convert.ToInt32(grId)) ;
				GetComboGrid(volId, siteId, ViewState["GameCode"].ToString()) ;
				GetOrganizationList(siteId) ;
			} 
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Volunteer Information: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Volunteer Information: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Volunteer Information: " + err.Message) ;}
		}

		private void VolDeleteButton_Click(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			Vha.Vtk.Games.GamesRegistration grhdl = null ;
			string grId ;
			try
			{
				//get information from grid
				grId = e.Item.Cells[0].Text.ToString() ;
				//create handle
				grhdl = new Vha.Vtk.Games.GamesRegistration(Convert.ToInt32(grId), VtkUtility.GetAppCon()) ;
				//delete and save
				grhdl.Delete() ;
				grhdl.Save() ;
				grhdl.Dispose() ;

				//update grid
				VolGridUpdate(Convert.ToInt32(ViewState["GameId"].ToString())) ;
			} 
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Volunteer Information: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Volunteer Information: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Volunteer Information: " + err.Message) ;}
		}

		private void PostButton_Click(object sender, System.EventArgs e)
		{
			SaveData() ;
		}

		private void FinishButton_Click(object sender, System.EventArgs e)
		{
			VolGridUpdate(Convert.ToInt32(ViewState["GameId"].ToString())) ;
			GamesListPanel.Visible = false ;
			GameVolunteersPanel.Visible = true ;
			VolunteerChooserPanel.Visible = false ;
			VolunteerRegistrationPanel.Visible = false ;
		}

		private void EditCombinationButton_Click(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			//get selected Combination
			string comId = e.Item.Cells[1].Text;
			//string comId = ComboGrid.SelectedItem.Cells[1].Text ;
			try
			{
				//create handle 
				Vha.Vtk.TimeKeeping.CombinationAssignment comhdl = new Vha.Vtk.TimeKeeping.CombinationAssignment(Convert.ToInt32(comId), VtkUtility.GetAppCon()) ;
				ViewState["ComId"] = comId ;

				//set fields value
				CodeLabel.Text = comhdl.CombinationCode ;
				VtkUtility.SetSelectedSingle(OrganizationList.Items, comhdl.OrganizationId.ToString()) ;
				VtkUtility.SetSelectedSingle(ServiceList.Items, comhdl.BenefitingServiceId.ToString()) ;
				VtkUtility.SetSelectedSingle(WorkdayList.Items, comhdl.WorkdayScheduleId.ToString()) ;
				InactiveCheckBox.Checked = comhdl.IsInactive ;
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Combination record: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Combination record: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Combination record: " + err.Message) ;}
		}

		private void RideNeedCheck_Click(object sender, System.EventArgs e)
		{
			if (RideNeedCheck.Checked)
			{
				RiderLocationLabel.Visible = true ;
				RiderLocationAstrix.Visible = true ;
				RiderLocationText.Visible = true ;
			}
			else
			{
				RiderLocationLabel.Visible = false ;
				RiderLocationAstrix.Visible = false ;
				RiderLocationText.Visible = false ;
			}
		
		}

		private void SearchButton_Click(object sender, System.EventArgs e)
		{
			if (SearchText != null)
			{
				try
				{
					GameVolunteersGrid.CurrentPageIndex = 0;
					VolGridUpdate(Convert.ToInt32(ViewState["GameId"])) ;
				}
				catch (VhaValidationException valErr)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error searching the table: " + valErr.Message) ;}
				catch (VhaTransactionException transErr)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error searching the table: " + transErr.Message) ;}
				catch (Exception err)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error searching the table: " + err.Message) ;}
			}
			else
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "You must enter a Name to use for searching!") ;}
		}

		private void ResetButton_Click(object sender, System.EventArgs e)
		{
			try
			{
				SearchText.Text = string.Empty ;
				GameVolunteersGrid.CurrentPageIndex = 0;
				SearchOptionList.SelectedIndex = 0 ;
				VolGridUpdate(Convert.ToInt32(ViewState["GameId"])) ;
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error searching the table: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error searching the table: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error searching the table: " + err.Message) ;}
		}

		#endregion

		#region Section: Private Methods

		private void RefreshVolChooser()
		{
			VolunteerList.Items.Clear() ;
			VolunteerList.Items.Add(new ListItem(emptyText,int.MinValue.ToString()));
			AddButton.Enabled = false ;
			ChooseButton.Enabled = false ;
			VolunteerList.Enabled = false ;
			MatchLabel.Visible = false ;
		}

		private void RefreshVolEdit()
		{
			//clear all registration fields
			FirstTimeCheck.Checked = false ;
			//set default to 'none' id=6
			VtkUtility.SetSelectedSingle(ShirtSizeList.Items, "6") ;
			RideNeedCheck.Checked = false ;
			RiderLocationText.Text = string.Empty ;
			RiderLocationText.Visible = false ;
			RiderLocationLabel.Visible = false ;
			RiderLocationAstrix.Visible = false ;
			LodgingCodeText.Text = string.Empty ;
			ServiceList.SelectedIndex = -1 ;
			WorkdayList.SelectedIndex = -1 ;
			ViewState["VolunteerId"] = string.Empty ;
			ViewState["VolStationId"] = string.Empty ;
			ViewState["ComId"] = string.Empty ;
		}

		private string CheckFields()
		{
			bool flag = false ;
			string errMsg = string.Empty ;
			//If ride needed than must have rider location, else set to null
			if (RideNeedCheck.Checked)
			{
				if (RiderLocationText.Text == string.Empty)
				{
					errMsg = "Rider Location is Required" ;
					flag = true ;
				}
			}
			else
			{ RiderLocationText.Text = string.Empty ;}

			//check combo codes, must have all or none
			if ((OrganizationList.SelectedIndex > 0 && ((WorkdayList.SelectedIndex < 1) || (ServiceList.SelectedIndex < 1))) ||
				(WorkdayList.SelectedIndex > 0 && ((OrganizationList.SelectedIndex < 1) || (ServiceList.SelectedIndex < 1))) ||
				(ServiceList.SelectedIndex > 0 && ((OrganizationList.SelectedIndex < 1) || (WorkdayList.SelectedIndex < 1))))
			{
				if (flag)
				{ errMsg = errMsg + ", " ;}
				errMsg = errMsg + "Must select all fields for a Combination Code or none!" ;
			}

			return errMsg ;
		}

		private void VolGridUpdate(int gameId)
		{
			//update GameVolunteersGrid
			//bind to grid: [0]=Id, [1]=volId, [2]=stationId, [3]=profileId, [5]=volName, [6]=ssn, [7]=station 
			string sText = string.Empty ;
			string sOption = string.Empty ;
			if (SearchText.Text.Length > 0)
			{ sText = SearchText.Text ;}
			sOption = SearchOptionList.SelectedItem.Value ;

			DataSet ds = Vha.Vtk.Games.GamesRegistration.GetQuickListByGameSchedule(gameId) ;
			//if we have search field, do search, else do sort
			if (sText != string.Empty)
			{ ds.Tables["GamesRegistrationList"].DefaultView.RowFilter =  sOption + " LIKE '" + sText + "*'" ;}
			else
			{ ds.Tables["GamesRegistrationList"].DefaultView.Sort = sOption ;}
			DataTable dt = ds.Tables["GamesRegistrationList"] ;
			//if no rows, show 'no volunteer registered' message and not pager panel
			if (dt.Rows.Count == 0)
			{
				NoVolunteerLabel.Visible = true ;
				PagerPanel.Visible = false ;
				SearchPanel.Visible = false ;
			}
			else
			{
				GameVolunteersGrid.DataSource = dt ;
				GameVolunteersGrid.DataBind() ;
				SetPagerStats();
				NoVolunteerLabel.Visible = false ;
				PagerPanel.Visible = true ;
				SearchPanel.Visible = true ;
			}
			ds.Dispose() ;
			dt.Dispose() ;
		}

		private void GetLists()
		{
			//get lists that are constant
			//Get the DataView of Shirt Sizes.
			DataSet ds = ShirtSize.GetQuickList();
			DataTable dt = ds.Tables["ShirtSizeList"];
			//Set the DropDropList for the ShirtSizes.
			ShirtSizeList.DataSource = dt ;
			ShirtSizeList.DataTextField = "SizeName";
			ShirtSizeList.DataValueField = "Id";
			ShirtSizeList.DataBind();
			//set default to 'none' id=6
			VtkUtility.SetSelectedSingle(ShirtSizeList.Items, "6") ;
			ds.Dispose() ;
			dt.Dispose() ;

			//populate list of workday, get dataset
			DataSet dswk = ScheduleWorkday.GetQuickList() ;
			dswk.Tables["ScheduleWorkdayList"].DefaultView.Sort = "DisplayName ASC" ;
			DataTable dtwk = dswk.Tables["ScheduleWorkdayList"] ;
			WorkdayList.DataSource = dtwk ;
			//define columns in list box
			WorkdayList.DataTextField = "DisplayName" ;
			WorkdayList.DataValueField = "ID" ;
			WorkdayList.DataBind() ;
			//Create the default selection for this ddl.
			WorkdayList.Items.Insert(0, new ListItem(" - Select Schedule Workday - ","-1"));
			dswk.Dispose() ;
			dtwk.Dispose() ;

			//populate list for Employee status
			DataSet dses = Vha.Vtk.Games.VAEmployeeStatus.GetQuickList() ;
			DataTable dtes = dses.Tables["VAEmployeeStatusList"] ;
			EmployeeStatusList.DataTextField = "Description" ;
			EmployeeStatusList.DataValueField = "ID" ;
			EmployeeStatusList.DataSource = dtes ;
			EmployeeStatusList.DataBind() ;
			//Create the default selection for this ddl.
			EmployeeStatusList.Items.Insert(0, new ListItem(" - Select VA Employee Status - ","-1"));
			dses.Dispose() ;
			dtes.Dispose() ;
		}

		private void GetServiceList(string gameCode)
		{
			//the code was commented out and the new code added below to place the subdivision
			//for the service in the list.

			//get service list using game code
			//ServiceList.DataSource = Service.GetQuickListForGames(gameCode);
			//ServiceList.DataTextField = "DisplayName";
			//ServiceList.DataValueField = "Id";
			//ServiceList.DataBind();
			//Create the default selection for the ddl.
			//ServiceList.Items.Insert(0,new ListItem(" - Select Service Code - ","-1"));

			try 
			{
				DataSet dsGameService = Vha.Vtk.Common.Service.GetQuickListForGames(gameCode);
				DataTable dtGameService = dsGameService.Tables["GamesServiceCodes"];

				if (dtGameService.Rows.Count > 0)
				{
					dtGameService.Columns.Add("ServiceAndCode", System.Type.GetType("System.String"));
					foreach (DataRow dr in dtGameService.Rows)
					{
						string s = String.Copy("(" + dr["ServiceCode"] + ")  " + dr["Subdivision"] + " " + dr["ServiceName"]);
						dr["ServiceAndCode"] = s;
					}
					ServiceList.DataTextField = "ServiceAndCode";
					ServiceList.DataValueField = "ID";
					ServiceList.DataSource = dtGameService;
					ServiceList.DataBind();
					dtGameService.Dispose();
					ServiceList.Items.Insert(0,new ListItem(" - Select Service Code - ","-1"));
				}
				else
				{
					VtkUtility.ErrMsgAdd(ErrorMessage, "No services found for game schedule");
				}
			} 
			catch (Exception err) 
			{
				VtkUtility.ErrMsgAdd(ErrorMessage, err.Message, "VTK.Games.GamesRegistration");
			}
		}

		private void GetOrganizationList(int siteId)
		{
			//gets volunteer's site organization list and combination codes
			//Set the DropDownList for the Vha.Vtk.Common.Organization
			OrganizationList.DataSource = Organization.GetSiteActiveQuickListByName(siteId) ;
			OrganizationList.DataTextField = "DisplayName";
			OrganizationList.DataValueField = "ID";
			OrganizationList.DataBind();
			//Create the default selection
			OrganizationList.Items.Insert(0,new ListItem(" - Select Organization - ","-1"));
		}

		private void GetComboGrid(int volId, int siteId, string gameCode)
		{
			try
			{
				//populate list of Combinations, get dataset,
				DataSet ds = Vha.Vtk.TimeKeeping.CombinationAssignment.GetQuickListForGames(volId, siteId, gameCode) ;
				DataTable dt = ds.Tables["CombinationAssignmentList"] ;

				ComboGrid.DataSource = dt ;
				ComboGrid.DataBind() ;
				ds.Dispose() ;
				dt.Dispose() ;
				//reset viewstate
				ViewState["ComId"] = string.Empty ;
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Combination List: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Combination List: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Combination List: " + err.Message) ;}
		}

		private void SetGameRegInfo(int grId)
		{
			//define handles
			Vha.Vtk.Games.GamesRegistration grhdl = null ;
			int volId = Convert.ToInt32(ViewState["VolunteerId"].ToString()) ;
			Vha.Vtk.TimeKeeping.Volunteer volhdl ;

			grhdl = new Vha.Vtk.Games.GamesRegistration(grId, VtkUtility.GetAppCon()) ;
			//update ViewState
			ViewState["GameRegId"] = grId ;
			ViewState["VolProfileId"] = grhdl.StationProfilesId.ToString() ;
			ViewState["GameRegVersion"] = grhdl.Version.ToString() ;

			//get values
			FirstTimeCheck.Checked = grhdl.FirstTimeParticipant ;
			LodgingCodeText.Text = grhdl.LodgingCode ;
			VtkUtility.SetSelectedSingle(ShirtSizeList.Items, grhdl.ShirtSizeId.ToString()) ;
			VolunteerNameLabel.Text = ViewState["VolunteerName"].ToString() ;
			//if they need a ride, show rider location
			RideNeedCheck.Checked = grhdl.TransportationStatus ;
			if (RideNeedCheck.Checked)
			{
				RiderLocationText.Text = grhdl.TransportationStation ;
				RiderLocationText.Visible = true ;
				RiderLocationLabel.Visible = true ;
				RiderLocationAstrix.Visible = true ;
			}

			//check if volunteer is VA employee
			volhdl = new Vha.Vtk.TimeKeeping.Volunteer(volId, VtkUtility.GetAppCon()) ;
			if (volhdl.IsVAEmployee)
			{
				EmployeeStatusLabel.Visible = true ;
				EmployeeStatusList.Visible = true ;
				VtkUtility.SetSelectedSingle(EmployeeStatusList.Items, grhdl.VAEmployeeStatusId.ToString()) ;
			}
			else
			{
				EmployeeStatusLabel.Visible = false ;
				EmployeeStatusList.Visible = false ;
			}
			volhdl.Dispose() ;
			grhdl.Dispose() ;
		}

		private void GetVolunteerInfo(int volId, int siteId)	
		{
			int grId = 0 ;
			int gameId = Convert.ToInt32(ViewState["GameId"].ToString()) ;
			string profId ;
			Vha.Vtk.TimeKeeping.Volunteer volhdl ;
			RefreshVolEdit() ;
			//need ViewStatep["VolunteerName"] and ViewState["GameCode"]
			ViewState["VolunteerId"] = volId.ToString() ;
			ViewState["VolStationId"] = siteId.ToString() ;
			VolunteerNameLabel.Text = ViewState["VolunteerName"].ToString() ;
			profId = StationProfile(volId, siteId) ;
			ViewState["VolProfileId"] = profId ;
			grId = GamesLib.GamesRegistration.FindGamesRegistrationId(gameId, Convert.ToInt32(profId)) ;

			//setup to edit registration
			GamesListPanel.Visible = false ;
			GameVolunteersPanel.Visible = false ;
			VolunteerChooserPanel.Visible = false ;
			VolunteerRegistrationPanel.Visible = true ;

			//if volunteer is already registered, update registration fields
			if (grId > 0)
			{ SetGameRegInfo(grId) ;}
			else
			{
				//check if volunteer is VA employee
				volhdl = new Vha.Vtk.TimeKeeping.Volunteer(volId, VtkUtility.GetAppCon()) ;
				if (volhdl.IsVAEmployee)
				{
					EmployeeStatusLabel.Visible = true ;
					EmployeeStatusList.Visible = true ;
				}
				else
				{
					EmployeeStatusLabel.Visible = false ;
					EmployeeStatusList.Visible = false ;
				}
				volhdl.Dispose() ;
				ViewState["GameRegId"] = string.Empty ;
			}

			//populate Volunteer Organization and Combination codes
			GetOrganizationList(siteId) ;
			GetComboGrid(volId, siteId, ViewState["GameCode"].ToString()) ;
		}

		private string StationProfile(int volId, int siteId)
		{
			//gets volunteer's station profile
			string profId = "0" ;
			DataSet ds = Vha.Vtk.TimeKeeping.StationProfile.GetQuickListByVolAndSite(volId, siteId);
			DataTable dt = ds.Tables["StationProfileList"];
			//should only have 1 row
			if(dt.Rows.Count == 1)
			{
				profId = dt.Rows[0]["Id"].ToString() ;
			}
			else if(dt.Rows.Count == 0)
				throw new VhaException("No Volunteer was found with the specified VolunteerID and StationID combination provided.");
			else if(dt.Rows.Count > 1)
				throw new VhaException("More than one Volunteer was found with the VolunteerID and StationID combination provided.");
						
			ds.Dispose();
			dt.Dispose();

			return profId ;
		}

		private void SaveData()
		{
			//define handles & ids
			Vha.Vtk.Games.GamesRegistration grhdl = null ;
			Vha.Vtk.TimeKeeping.CombinationAssignment comhdl = null ;

			string grId ;
			string comId ;
			bool versionOk = true ;
			string checkdata = CheckFields() ;

			if (checkdata != string.Empty)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, checkdata) ;}
			else
			{
				try
				{
					//check if new or existing record for games registration
					if (ViewState["GameRegId"].ToString() != string.Empty)
					{
						grId = ViewState["GameRegId"].ToString() ;
						grhdl = new Vha.Vtk.Games.GamesRegistration(Convert.ToInt32(grId), VtkUtility.GetAppCon()) ;
					}
					else
					{
						//new record
						grhdl = Vha.Vtk.Games.GamesRegistration.AddRecord(VtkUtility.GetAppCon()) ;
					}

					if (versionOk)
					{
						//file fields for game registration
						grhdl.FirstTimeParticipant = FirstTimeCheck.Checked ;
						grhdl.TransportationStatus = RideNeedCheck.Checked ;
						grhdl.TransportationStation = RiderLocationText.Text ;
						grhdl.LodgingCode = LodgingCodeText.Text ;
						grhdl.GameScheduleId = Convert.ToInt32(ViewState["GameId"].ToString()) ;
						grhdl.StationProfilesId = Convert.ToInt32(ViewState["VolProfileId"].ToString()) ;

						if (Convert.ToInt32(ShirtSizeList.SelectedItem.Value) < 6)
							grhdl.ShirtSizeId = Convert.ToInt32(ShirtSizeList.SelectedItem.Value) ;

						if (EmployeeStatusList.SelectedIndex > 0)
							grhdl.VAEmployeeStatusId = Convert.ToInt32(EmployeeStatusList.SelectedItem.Value) ;

						//save, reset id and dispose
						grhdl.Save() ;

						ViewState["GameRegId"] = grhdl.ID.ToString() ;
						ViewState["GameRegVersion"] = grhdl.Version.ToString();

						grhdl.Dispose() ;

						//check if new or existing record for combination code
						if (ViewState["ComId"].ToString() != string.Empty)
						{
							comId = ViewState["ComId"].ToString() ;
							comhdl = new Vha.Vtk.TimeKeeping.CombinationAssignment(Convert.ToInt32(comId), VtkUtility.GetAppCon()) ;
						}
						else
						{
							//new record only if they have data, check Organization
							if (OrganizationList.SelectedIndex > 0)
								comhdl = Vha.Vtk.TimeKeeping.CombinationAssignment.AddRecord(Convert.ToInt32(ViewState["VolProfileId"]), VtkUtility.GetAppCon()) ;
						}

						//file fields for combination code if we have a handle, comhdl
						if (comhdl != null)
						{
							comhdl.OrganizationId = Convert.ToInt32(OrganizationList.SelectedItem.Value) ;
							comhdl.BenefitingServiceId = Convert.ToInt32(ServiceList.SelectedItem.Value) ;
							comhdl.WorkdayScheduleId = Convert.ToInt32(WorkdayList.SelectedItem.Value) ;

							if (InactiveCheckBox.Checked)
							{comhdl.IsInactive = true ;}
							else
							{ comhdl.IsInactive = false ;}

							//save and dispose
							comhdl.Save() ;
							comhdl.Dispose() ;
						}

						//update confirmation message
						ConfirmationMessage.Text = "Record Posted!" ;
						//update combo DataGrid & clear fields
						GetComboGrid(Convert.ToInt32(ViewState["VolunteerId"]), Convert.ToInt32(ViewState["VolStationId"]), ViewState["GameCode"].ToString()) ;
						OrganizationList.SelectedIndex = -1 ;
						ServiceList.SelectedIndex = -1 ;
						WorkdayList.SelectedIndex = -1 ;
					}
					
					GamesListPanel.Visible = false ;
					GameVolunteersPanel.Visible = false ;
					VolunteerChooserPanel.Visible = false ;
					VolunteerRegistrationPanel.Visible = true ;
				} 
				catch (VhaValidationException valErr)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error posting Volunteer Information: " + valErr.Message) ;}
				catch (VhaTransactionException transErr)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error posting Volunteer Information: " + transErr.Message) ;}
				catch (Exception err)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error posting Volunteer Information: " + err.Message) ;}
			}
		}
		#endregion

		#region Paging Data
		private void PageGrid(object obj, DataGridPageChangedEventArgs e)
		{
			GameVolunteersGrid.CurrentPageIndex = 0;
			VolGridUpdate(Convert.ToInt32(ViewState["GameId"])) ;
		}

		private void SetPagerStats()
		{
			int currentPageIndex = GameVolunteersGrid.CurrentPageIndex + 1;
			int pageCount = GameVolunteersGrid.PageCount;

			CurrentPage.Text = currentPageIndex.ToString();
			PageCount.Text = pageCount.ToString();
		}

		private void Pager_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{			
			ImageButton objSender = (ImageButton)sender;
			switch(objSender.CommandArgument)
			{
				case "PREV":
					if(GameVolunteersGrid.CurrentPageIndex > 0)
						GameVolunteersGrid.CurrentPageIndex --;
					break;
				case "NEXT":
					if(GameVolunteersGrid.CurrentPageIndex < (GameVolunteersGrid.PageCount - 1))
						GameVolunteersGrid.CurrentPageIndex ++;
					break;
				case "GO":
					if((Convert.ToInt32(CurrentPage.Text) <= GameVolunteersGrid.PageCount) && (Convert.ToInt32(CurrentPage.Text) != 0))
					{
						GameVolunteersGrid.CurrentPageIndex = Convert.ToInt32(CurrentPage.Text) - 1;
					}
					break;
				case "FIRST":
					GameVolunteersGrid.CurrentPageIndex = 0;
					break;
				case "LAST":					
					GameVolunteersGrid.CurrentPageIndex = GameVolunteersGrid.PageCount - 1;
					break;
			}
			CurrentPage.Text = GameVolunteersGrid.CurrentPageIndex.ToString();
			VolGridUpdate(Convert.ToInt32(ViewState["GameId"])) ;
		}
		#endregion

	}
}
