using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using System.Security.Principal;
using Vha.Vtk.Common;
using Vha.Vtk.TimeKeeping;
using Vha.Vtk.Kernel.Common;
using Vha.Vtk.WebControlLibrary;
using VTK.Utility;
using Vha.Vss.Utility;
using Vha.Vtk.Games;


namespace VTK.Games
{
	/// <summary>
	/// Summary description for VolunteerTimeEdit.
	/// </summary>
	public class GamesSingleDayEdit : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DropDownList CombinationList;
		protected System.Web.UI.WebControls.Button PostButton;
		protected Vha.Vtk.WebControlLibrary.VtkPageHeader VtkPageHeader1;
		protected System.Web.UI.WebControls.Label ConfirmationMessage;
		protected System.Web.UI.WebControls.Button DeleteButton;
		protected System.Web.UI.WebControls.Label DataGridHeader;
		protected System.Web.UI.WebControls.DataGrid TimeSheetDataGrid;
		protected System.Web.UI.WebControls.DataGrid CombinationDataGrid;
		protected System.Web.UI.WebControls.DropDownList DayList;
		protected System.Web.UI.WebControls.DropDownList HourList;
		protected System.Web.UI.WebControls.ListBox TermList;
		protected System.Web.UI.WebControls.DataGrid GamesList;
		protected System.Web.UI.WebControls.Panel EditPanel;
		protected System.Web.UI.WebControls.ImageButton LAST;
		protected System.Web.UI.WebControls.ImageButton Next;
		protected System.Web.UI.WebControls.ImageButton Previous;
		protected System.Web.UI.WebControls.ImageButton FIRST;
		protected System.Web.UI.WebControls.Panel PagerPanel;
		protected System.Web.UI.WebControls.DataGrid GameVolunteersGrid;
		protected System.Web.UI.WebControls.Button ResetButton;
		protected System.Web.UI.WebControls.Button SearchButton;
		protected System.Web.UI.WebControls.TextBox SearchText;
		protected System.Web.UI.WebControls.DropDownList SearchOptionList;
		protected System.Web.UI.WebControls.Panel SearchPanel;
		protected System.Web.UI.WebControls.Panel GameVolunteersPanel;
		protected System.Web.UI.WebControls.Label ChooseVolunteerLabel;
		protected System.Web.UI.WebControls.ImageButton GO;
		protected System.Web.UI.WebControls.Label PageCount;
		protected System.Web.UI.WebControls.TextBox CurrentPage;
		protected System.Web.UI.WebControls.Panel Panel1;
		protected System.Web.UI.WebControls.ImageButton ImageButton1;
		protected System.Web.UI.WebControls.ImageButton ImageButton2;
		protected System.Web.UI.WebControls.ImageButton ImageButton3;
		protected System.Web.UI.WebControls.ImageButton ImageButton4;
		protected System.Web.UI.WebControls.ImageButton ImageButton5;
		protected System.Web.UI.WebControls.Button btnReset;
		protected System.Web.UI.WebControls.Button btnSearch;
		protected System.Web.UI.WebControls.DropDownList SearchColumn;
		protected System.Web.UI.WebControls.TextBox SearchTxt;
		protected System.Web.UI.WebControls.Label PageCount2;
		protected System.Web.UI.WebControls.TextBox CurrentPage2;
		protected System.Web.UI.WebControls.Label ErrorMessage;
	
		//Games Data
		protected int HostStationId;
		protected string HostStationName;
		protected int GameTypeId;
		protected int GameId;
		protected DateTime StartDate;
		protected DateTime EndDate;
		protected string GameCode;

		//Volunteer Data
		protected string VolunteerName;
		protected int VolunteerId;
		protected System.Web.UI.WebControls.ImageButton FIRST2;
		protected System.Web.UI.WebControls.ImageButton PREV2;
		protected System.Web.UI.WebControls.ImageButton GO2;
		protected System.Web.UI.WebControls.ImageButton NEXT2;
		protected System.Web.UI.WebControls.ImageButton LAST2;
		protected int VolStationId;
		
		public GamesSingleDayEdit()
		{
			Page.Init += new System.EventHandler(Page_Init);
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			try 
			{
				if (VtkPageHeader1.IsDivSelected("Single Day Hours")) 
				{
					if (!Page.IsPostBack)
					{
						//display gamelist
						GamesList.Visible = false ;
						GameVolunteersPanel.Visible = true ;
						EditPanel.Visible = false ;
						TimeSheetDataGrid.Visible = true ;

						DataSet latestSchedule = GamesSchedule.GetQuickListByInstitutionId(Convert.ToInt32(VtkPageHeader1.DivSelectedId));
						DataTable scheduleDt = latestSchedule.Tables["GamesList"];

						/********************************************************************/
						/*               SAVE THE DATA FROM GAMESLIST PAGE    							*/
						/********************************************************************/
								
						if(scheduleDt.Rows.Count == 1)
						{
							ViewState["HostStationId"]	= scheduleDt.Rows[0]["HostInstitutionId"].ToString() ;
							ViewState["HostStationName"]= scheduleDt.Rows[0]["HostInstitutionName"].ToString() ;
							ViewState["GameTypeId"]		= scheduleDt.Rows[0]["GameTypeId"].ToString() ;
							ViewState["GameId"]			= scheduleDt.Rows[0]["ID"].ToString() ;
							ViewState["StartDate"]		= scheduleDt.Rows[0]["StartDate"].ToString() ;
							ViewState["EndDate"]		= scheduleDt.Rows[0]["EndDate"].ToString() ;
							ViewState["GameCode"]		= scheduleDt.Rows[0]["GameCode"].ToString() ;

							/********************************************************************/
							/*               SETUP FOR VOLUNTEER REGISTRATION INFO							*/
							/********************************************************************/
							int GameId = Convert.ToInt32(scheduleDt.Rows[0]["ID"].ToString());
							DateTime StartDate = Convert.ToDateTime(scheduleDt.Rows[0]["StartDate"].ToString());
							DateTime EndDate = Convert.ToDateTime(scheduleDt.Rows[0]["EndDate"].ToString());

							SetFields() ;
							VolGridUpdate(GameId) ;
							BuildDayList(StartDate, EndDate, true) ;
						}
						else if (scheduleDt.Rows.Count > 1)
						{
							//display gamelist
							GamesList.Visible = true ;
							GameVolunteersPanel.Visible = false ;
							EditPanel.Visible = false ;
							TimeSheetDataGrid.Visible = true ;
						}
						else if (scheduleDt.Rows.Count == 0)
						{ VtkUtility.ErrMsgAdd(ErrorMessage, "You have no permissions for any Games!") ;}
					}
					
					//save the stationId on the form
					Page.RegisterHiddenField("StationId", VtkPageHeader1.DivSelectedId.ToString()) ;
				}
				else
				{ Response.Redirect("/Vtk/Welcome.aspx?" + VtkPageHeader.GetURLParameterString()+"=" + VtkPageHeader1.DivSelectedId) ;}
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Time Sheets List: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Time Sheets List: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Time Sheets List: " + err.Message) ;}
		}

		private void Page_Init(object sender, EventArgs e)
		{
			InitializeComponent();
		}

		#region Section: Private Methods

		private void SetFields()
		{
			try
			{
				//clear fields
				ChooseVolunteerLabel.Text = string.Empty ;
				CombinationList.SelectedIndex =0 ;
				HourList.SelectedIndex = 0 ;
				DeleteButton.Enabled = false ;

				ViewState["timeId"] = string.Empty ;
				ViewState["timeVersion"] = string.Empty ;
				ViewState["volId"] = string.Empty ;
				ViewState["VolunteerName"] = string.Empty ;
				ViewState["stnId"] = string.Empty ;
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the setting fields: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the setting fields: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the setting fields: " + err.Message) ;}
		}

		private string MissingFields()
		{
			string fields = string.Empty ;
			bool flag = false ;
			if (ViewState["volId"].ToString() == string.Empty)
			{
				fields = "Volunteer" ;
				flag = true ;
			}
			else if (Convert.ToInt32(CombinationList.SelectedItem.Value) < 0)
			{
					if (flag)
					{ fields = fields + ", " ;}
					fields = fields + "Combination Code" ;
					flag = true ;
			}
			if (HourList.SelectedIndex < 1)
			{
				if (flag)
				{ fields = fields + ", " ;}
				fields = fields + "Hours" ;
				flag = true ;
			}

			return fields ;
		}

		private void GetDataGrid(DateTime tkDate)
		{
			try
			{
				string sText = string.Empty ;
				string sOption = string.Empty ;

				if (SearchTxt.Text.Length > 0)
					sText = SearchTxt.Text ;

				sOption = SearchColumn.SelectedItem.Value ;

				DataSet dsts = VolunteerHours.GetQuickListForGamesByDate(tkDate, ViewState["GameCode"].ToString()) ;
				if (sText != string.Empty)
					dsts.Tables["GetQuickListForGamesByDate"].DefaultView.RowFilter =  sOption + " LIKE '" + sText + "*'" ;
				else
					dsts.Tables["GetQuickListForGamesByDate"].DefaultView.Sort = sOption ;

				DataTable dtts = dsts.Tables["GetQuickListForGamesByDate"] ;
				//bind datagrid to DataTable
				TimeSheetDataGrid.DataSource = dtts ;
				TimeSheetDataGrid.DataBind() ;
				dsts.Dispose() ;
				SetPagerStats("Pager2");
				DataGridHeader.Text = tkDate.Date.ToShortDateString() ;
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Current Time Sheets: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Current Time Sheets: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Current Time Sheets: " + err.Message) ;}
		}

		private void GetCombinationList(int volId, int siteId, string gameCode)
		{
			try
			{
				//populate list of Combination, get dataset
				//ref. Vha.Vtk.TimeKeeping.CombinationAssignment
				//DataSet dscom = CombinationAssignment.GetQuickListForGames(volId, siteId, gameCode) ;
				DataSet dscom = CombinationAssignment.GetActiveQuickListForGames(volId, siteId, gameCode) ;
				DataTable dtcom = dscom.Tables["CombinationAssignmentList"] ;

				//define columns in list box
				CombinationList.DataTextField = "DisplayName" ;
				CombinationList.DataValueField = "Id" ;
				// if no combinations, show message
				if (dtcom.Rows.Count < 1)
				{
					//add a row
					DataRow drcom = dtcom.NewRow() ;
					drcom["DisplayName"] = " *Volunteer has no Combination Code* " ;
					drcom["Id"] = "-1" ;
					dtcom.Rows.Add(drcom) ;
				}

				//bind list box to DataTable and cleanup
				CombinationList.DataSource = dtcom ;
				CombinationList.DataBind() ;
				//bind to datagrid
				CombinationDataGrid.DataSource = dtcom ;
				CombinationDataGrid.DataBind() ;
				dscom.Dispose() ;
				dtcom.Dispose() ;
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Combination List: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Combination List: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Combination List: " + err.Message) ;}
		}

		private void RefreshVolunteer()
		{
			string VolunteerName = ViewState["VolunteerName"].ToString() ;
			int volId = Convert.ToInt32(ViewState["volId"].ToString()) ;
			int volSiteId = Convert.ToInt32(ViewState["stnId"].ToString()) ;
			int gameId = Convert.ToInt32(ViewState["GameId"].ToString()) ;
			string gameCode = ViewState["GameCode"].ToString() ;

			//volunteer has been choosen, update viewstate and remove choosercontrol
			ChooseVolunteerLabel.Text = VolunteerName ;
			GetCombinationList(volId, volSiteId, gameCode) ;
		}

		private void GetTimeButton_Click(object sender, System.EventArgs e)
		{
			try
			{
				//convert DayList to date
				DateTime DateWorked = Convert.ToDateTime(DayList.SelectedItem.Text) ;				
				GetDataGrid(DateWorked) ;
				SetPagerStats("Pager2");
				ViewState["date"] = DayList.SelectedItem.ToString();
				/*
				string VolunteerName = Request.Form["VolunteerName"] ;
				int volId = Convert.ToInt32(Request.Form["VolunteerId"]) ;
				int volSiteId = Convert.ToInt32(Request.Form["VolStationId"]) ;
				int gameId = Convert.ToInt32(Request.Form["GameId"]) ;
				string gameCode = Request.Form["GameCode"] ;

				//volunteer has been choosen, update viewstate and remove choosercontrol
				ChooseVolunteerLabel.Text = VolunteerName ;
				GetCombinationList(volId, volSiteId, gameCode) ;

				Page.RegisterHiddenField("VolunteerName", VolunteerName);
				Page.RegisterHiddenField("VolunteerId", volId.ToString());
				Page.RegisterHiddenField("VolStationId", volSiteId.ToString());
				Page.RegisterHiddenField("GameId", gameId.ToString());
				Page.RegisterHiddenField("GameCode", gameCode);

				//Get the TimeSheets Data Grid
				DateTime DateWorked = Convert.ToDateTime(DayList.SelectedItem.Text) ;

				//populate list of TimeSheets, get dataset(site, date, include closed records, srvCfg)
				DataSet dsts = VolunteerHours.GetQuickListForGamesByDate(DateWorked, gameCode.ToString()) ;
				dsts.Tables["GetQuickListForGamesByDate"].DefaultView.Sort = "DisplayName" ;
				DataTable dtts = dsts.Tables["GetQuickListForGamesByDate"] ;

				//bind datagrid to DataTable
				TimeSheetDataGrid.DataSource = dtts ;
				TimeSheetDataGrid.DataBind() ;
				dsts.Dispose() ;
				DataGridHeader.Text = DateWorked.Date.ToShortDateString() ;
				*/

			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error changing days: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the changing days: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the changing days: " + err.Message) ;}
		}

		private void BuildDayList(DateTime BeginDate, DateTime EndDate, bool SetTodaysDate)
		{
			TimeSpan TimeInDays = EndDate - BeginDate;
			int days = TimeInDays.Days + 1;
			int selectedIndex = 0;

			string[] dates = new string[days];
			for(int i = 0; i < days; i++)
			{
				dates[i] = BeginDate.AddDays(Convert.ToDouble(i)).ToShortDateString();
				if(dates[i] == DateTime.Now.ToShortDateString())
				{
					selectedIndex = i;
					ViewState["date"] = BeginDate.AddDays(Convert.ToDouble(i));
				}
			}
			
			DayList.DataSource = dates ;
			if(SetTodaysDate)
			{
				DayList.SelectedIndex = selectedIndex;
			}

			DayList.DataBind() ;

		}

		private void VolGridUpdate(int gameId)
		{
			//update GameVolunteersGrid
			//bind to grid: [0]=Id, [1]=volId, [2]=stationId, [3]=profileId, [5]=volName, [6]=ssn, [7]=station 
			string sText = string.Empty ;
			string sOption = string.Empty ;
			if (SearchText.Text.Length > 0)
			{ sText = SearchText.Text ;}
			sOption = SearchOptionList.SelectedItem.Value ;

			DataSet ds = Vha.Vtk.Games.GamesRegistration.GetQuickListByGameSchedule(gameId) ;
			//if we have search field, do search, else do sort
			if (sText != string.Empty)
			{ ds.Tables["GamesRegistrationList"].DefaultView.RowFilter =  sOption + " LIKE '" + sText + "*'" ;}
			else
			{ ds.Tables["GamesRegistrationList"].DefaultView.Sort = sOption ;}
			DataTable dt = ds.Tables["GamesRegistrationList"] ;
			//if no rows, show 'no volunteer registered' message and not pager panel
			
			if (dt.Rows.Count != 0)
			{
				GameVolunteersGrid.DataSource = dt ;
				GameVolunteersGrid.DataBind() ;
				SetPagerStats("Pager");
				PagerPanel.Visible = true ;
				SearchPanel.Visible = true ;
			}

			ds.Dispose() ;
			dt.Dispose() ;
		}

		private bool RecordExists()
		{
			// MSG 11/22/2004 Hour's breakout change.
			// Added routine to check now primary key components.
			for (int i = 0; i < TimeSheetDataGrid.Items.Count; i++)
			{
				DateTime dViewStateDate, dGridDate;
				dViewStateDate = Convert.ToDateTime(ViewState["date"].ToString());
				dGridDate = Convert.ToDateTime(TimeSheetDataGrid.Items[i].Cells[9].Text);

				if( ViewState["volId"].ToString() == TimeSheetDataGrid.Items[i].Cells[4].Text &&
					ViewState["stnId"].ToString() == TimeSheetDataGrid.Items[i].Cells[5].Text  &&
					ViewState["orgId"].ToString() == TimeSheetDataGrid.Items[i].Cells[6].Text  &&
					ViewState["svcId"].ToString() == TimeSheetDataGrid.Items[i].Cells[7].Text  &&
					ViewState["schId"].ToString() == TimeSheetDataGrid.Items[i].Cells[8].Text  &&
					dViewStateDate.ToShortDateString() == dGridDate.ToShortDateString() )
					return true;
			}
			return false;
		}

		#endregion

		#region Section: Private Events

		private void ResetButton_Click(object sender, System.EventArgs e)
		{
			try
			{
				Button objSender = (Button)sender;
				switch(objSender.ID)
				{
					case "ResetButton":
						//reset search fields
						SearchText.Text = string.Empty ;
						SearchOptionList.SelectedIndex = 0 ;
						GameVolunteersGrid.CurrentPageIndex = 0;
						VolGridUpdate(Convert.ToInt32(ViewState["GameId"].ToString())) ;
						break;
					case "btnReset":						
						//reset search fields
						SearchTxt.Text = string.Empty ;
						SearchColumn.SelectedIndex = 0 ;
						TimeSheetDataGrid.CurrentPageIndex = 0;
						GetDataGrid(Convert.ToDateTime(DayList.SelectedItem.Text)) ;
						SetPagerStats("Pager2");
						break;
				}
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error searching the table: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error searching the table: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error searching the table: " + err.Message) ;}
		}

		private void SearchButton_Click(object sender, System.EventArgs e)
		{
			Button objSender = (Button)sender;
			//Perform search for the Volunteer Pager
			if (SearchText != null && objSender.ID == "SearchButton")
			{
				try
				{
					GameVolunteersGrid.CurrentPageIndex = 0;
					VolGridUpdate(Convert.ToInt32(ViewState["GameId"])) ;
				}
				catch (VhaValidationException valErr)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error searching the table: " + valErr.Message) ;}
				catch (VhaTransactionException transErr)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error searching the table: " + transErr.Message) ;}
				catch (Exception err)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error searching the table: " + err.Message) ;}
			}
			//Perform search for the TimeSheet Pager
			else if (SearchTxt != null && objSender.ID == "btnSearch")
			{
				try
				{
					TimeSheetDataGrid.CurrentPageIndex = 0;
					DateTime DateWorked = Convert.ToDateTime(DayList.SelectedItem.Text) ;
					GetDataGrid(DateWorked);
					SetPagerStats("Pager2");
				}
				catch (VhaValidationException valErr)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error searching the table: " + valErr.Message) ;}
				catch (VhaTransactionException transErr)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error searching the table: " + transErr.Message) ;}
				catch (Exception err)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error searching the table: " + err.Message) ;}
			}
			else
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "You must enter a Name to use for searching!") ;}
		}
		private void Register_Click(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			try
			{
				
				/********************************************************************/
				/*               SAVE THE DATA FROM GAMESLIST PAGE    							*/
				/********************************************************************/
				
				ViewState["HostStationId"]		= e.Item.Cells[0].Text ;
				ViewState["HostStationName"]	= e.Item.Cells[3].Text ;
				ViewState["GameTypeId"]			= e.Item.Cells[1].Text ;
				ViewState["GameId"]				= e.Item.Cells[2].Text ;
				ViewState["StartDate"]			= e.Item.Cells[5].Text ;
				ViewState["EndDate"]			= e.Item.Cells[6].Text ;
				ViewState["GameCode"]			= e.Item.Cells[7].Text ;

				/********************************************************************/
				/*               SETUP FOR VOLUNTEER REGISTRATION INFO							*/
				/********************************************************************/

				int GameId = Convert.ToInt32(e.Item.Cells[2].Text);
				DateTime StartDate = Convert.ToDateTime(e.Item.Cells[5].Text);
				DateTime EndDate = Convert.ToDateTime(e.Item.Cells[6].Text);

				VolGridUpdate(GameId) ;
				BuildDayList(StartDate, EndDate, false) ;
				GetDataGrid(Convert.ToDateTime(DayList.SelectedItem.Text)) ;

				GamesList.Visible = false ;
				GameVolunteersPanel.Visible = false ;
				EditPanel.Visible = true ;
				TimeSheetDataGrid.Visible = true ;
				PostButton.Enabled = false ;

			} 
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Games List: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Games List: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Games List: " + err.Message) ;}
		}

		private void EditButton_Click(object sender, System.EventArgs e)
		{
			try
			{
				//get selected timesheet
				int ivolId = Convert.ToInt32(TimeSheetDataGrid.SelectedItem.Cells[4].Text);
				int istnId = Convert.ToInt32(TimeSheetDataGrid.SelectedItem.Cells[5].Text);
				int iorgId = Convert.ToInt32(TimeSheetDataGrid.SelectedItem.Cells[6].Text);
				int isvcId = Convert.ToInt32(TimeSheetDataGrid.SelectedItem.Cells[7].Text);
				int ischId = Convert.ToInt32(TimeSheetDataGrid.SelectedItem.Cells[8].Text);
				DateTime ddate = Convert.ToDateTime(TimeSheetDataGrid.SelectedItem.Cells[9].Text);
					
				string volName = TimeSheetDataGrid.SelectedItem.Cells[1].Text ;

				//create handle and open current record
				Vha.Vtk.TimeKeeping.VolunteerHours tshdl = new VolunteerHours(ivolId, istnId, iorgId, ischId, isvcId, ddate, VtkUtility.GetAppCon()) ;

				//clear fields
				SetFields() ;

				//set viewstate variables
				ViewState["volId"] = tshdl.VolunteerId ;
				ViewState["stnId"] = tshdl.StationId ;
				ViewState["orgId"] = tshdl.OrganizationId ;
				ViewState["svcId"] = tshdl.BenefitingServiceId ;
				ViewState["schId"] = tshdl.ScheduleId ;
				ViewState["date"] = tshdl.DateWorked ;
				ViewState["timeVersion"] = tshdl.Version.ToString();

				ViewState["VolunteerName"] = volName ;

				//get volunteer information
				RefreshVolunteer() ;

				//populate other fields
				if (tshdl.HoursWorked > 0)
				{ VtkUtility.SetSelectedSingle(HourList.Items, tshdl.HoursWorked.ToString()) ;}
				else
				{ HourList.SelectedIndex = 0 ;}

				int org = tshdl.OrganizationId ;
				int svc = tshdl.BenefitingServiceId ;
				int sch = tshdl.ScheduleId ;
				int comId = int.MinValue ;

				foreach (DataGridItem dgi in CombinationDataGrid.Items)
				{
					if (dgi.Cells[1].Text == org.ToString())
					{
						if (dgi.Cells[2].Text == sch.ToString())
						{
							if (dgi.Cells[3].Text == svc.ToString())
							{ comId = Convert.ToInt32(dgi.Cells[0].Text) ;}
						}
					}
				}
				if (comId > int.MinValue)
				{
					VtkUtility.SetSelectedSingle(CombinationList.Items,comId.ToString());
				}
				//enable buttons
				DeleteButton.Enabled = true ;
				PostButton.Enabled = true ;
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Time Sheet Record: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Time Sheet Record: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Time Sheet Record: " + err.Message) ;}
		}

		private void PostButton_Click(object sender, System.EventArgs e)
		{
			// MSG 11/22/2004 Hour's breakout change.
			// Removed ID as primary key added Vol ID, Stn ID, Org ID,
			// Svc ID, Sch ID and Dateworked as primary key.
			try
			{
				//check for required fields
				string missingdata = MissingFields() ;
				if (missingdata != string.Empty)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "The following field(s) are Required: " + missingdata) ;}
				else
				{
					//convert DayList to date
					DateTime DateWorked = Convert.ToDateTime(DayList.SelectedItem.Text) ;
					//flag to check if version number has changed
					bool versionOk = true ;
					int volId = Convert.ToInt32(ViewState["volId"].ToString()) ;
					Vha.Vtk.TimeKeeping.VolunteerHours tshdl ;

					//existing record
					if (RecordExists())
					{
						int ivolId = Convert.ToInt32(ViewState["volId"].ToString());
						int istnId = Convert.ToInt32(ViewState["stnId"].ToString());
						int iorgId = Convert.ToInt32(ViewState["orgId"].ToString());
						int isvcId = Convert.ToInt32(ViewState["svcId"].ToString());
						int ischId = Convert.ToInt32(ViewState["schId"].ToString());
						DateTime ddate = Convert.ToDateTime(ViewState["date"].ToString());
					
						//create handle and open current record
						tshdl = new VolunteerHours(ivolId, istnId, iorgId, ischId, isvcId, ddate, VtkUtility.GetAppCon()) ;

						//check version
						if (ViewState["timeVersion"].ToString() != tshdl.Version.ToString())
						{
							VtkUtility.ErrMsgAdd(ErrorMessage, "Current Volunteer Time Sheet record has changed while you were editing, Please press EXIT and start over. ") ;
							versionOk = false ;
						}
					}
						//new record
					else
					{
						//create handle and open new record
						tshdl = VolunteerHours.AddRecord(volId, VtkUtility.GetAppCon()) ;
					}
					if (versionOk)
					{
						//save current fields
						tshdl.StationId = Convert.ToInt32(ViewState["stnId"].ToString()) ;
						tshdl.DateWorked = DateWorked ;
						tshdl.HoursWorked = Convert.ToInt32(HourList.SelectedItem.Value.ToString()) ;
						//seperate combination, find in datagrid
						string comId = CombinationList.SelectedItem.Value.ToString() ;
						int org = int.MinValue ;
						int sch = int.MinValue ;
						int svc = int.MinValue ;

						foreach (DataGridItem dgi in CombinationDataGrid.Items)
						{
							if (dgi.Cells[0].Text == comId)
							{
								org = Convert.ToInt32(dgi.Cells[1].Text) ;
								sch = Convert.ToInt32(dgi.Cells[2].Text) ;
								svc = Convert.ToInt32(dgi.Cells[3].Text) ;
								break ;
							}
						}
						tshdl.OrganizationId = org ;
						tshdl.ScheduleId = sch ;
						tshdl.BenefitingServiceId = svc ;

						//save and close
						tshdl.Save() ;
						tshdl.Dispose() ;
						//update confirmation message
						ConfirmationMessage.Text = "Record Posted!" ;
						//update DataGrid
						GetDataGrid(DateWorked) ;

						//clear fields and disable buttons
						SetFields() ;
						DeleteButton.Enabled = false ;
						PostButton.Enabled = false ;
					}
				}
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error posting the Time Sheet Record: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error posting the Time Sheet Record: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error posting the Time Sheet Record: " + err.Message) ;}
		}

		private void DeleteButton_Click(object sender, System.EventArgs e)
		{
			// MSG 11/22/2004 Hour's breakout change.
			// Removed ID as primary key added Vol ID, Stn ID, Org ID,
			// Svc ID, Sch ID and Dateworked as primary key.

			if (RecordExists())
			{
				try
				{
					DateTime DateWorked;

					int ivolId = Convert.ToInt32(ViewState["volId"].ToString());
					int istnId = Convert.ToInt32(ViewState["stnId"].ToString());
					int iorgId = Convert.ToInt32(ViewState["orgId"].ToString());
					int isvcId = Convert.ToInt32(ViewState["svcId"].ToString());
					int ischId = Convert.ToInt32(ViewState["schId"].ToString());
					DateTime ddate = Convert.ToDateTime(ViewState["date"].ToString());
						
					Vha.Vtk.TimeKeeping.VolunteerHours tshdl ;

					//create handle and open current record
					tshdl = new VolunteerHours(ivolId, istnId, iorgId, ischId, isvcId, ddate, VtkUtility.GetAppCon()) ;

					DateWorked = tshdl.DateWorked.Date ;
					//delete, save and close
					tshdl.Delete() ;
					tshdl.Save() ;
					tshdl.Dispose() ;

					//update confirmation message
					ConfirmationMessage.Text = "Record Deleted!" ;
					//update DataGrid
					GetDataGrid(DateWorked) ;
					SetFields() ;
					PostButton.Enabled = false ;
				}
				catch (VhaValidationException valErr)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error deleting the Time Sheet Record: " + valErr.Message) ;}
				catch (VhaTransactionException transErr)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error deleting the Time Sheet Record: " + transErr.Message) ;}
				catch (Exception err)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error deleting the Time Sheet Record: " + err.Message) ;}
			}
		}

		private void VolGridEdit_Click(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			try
			{
				//get information from grid
				ViewState["VolunteerName"] = e.Item.Cells[5].Text.ToString() ;
				ViewState["volId"] = e.Item.Cells[1].Text.ToString() ;
				ViewState["stnId"] = e.Item.Cells[2].Text.ToString() ;
				RefreshVolunteer() ;
				//update timesheet data grid to selected date
				GetDataGrid(Convert.ToDateTime(DayList.SelectedItem.Text)) ;

				SetPagerStats("Pager2");

				PostButton.Enabled = true ;
				GamesList.Visible = false ;
				GameVolunteersPanel.Visible = false ;
				EditPanel.Visible = true ;
				TimeSheetDataGrid.Visible = true ;
			} 
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Volunteer Information: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Volunteer Information: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Volunteer Information: " + err.Message) ;}
		}

		private void ExitButton_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("../Index.aspx?" + VtkPageHeader.GetURLParameterString() + "=" + VtkPageHeader1.DivSelectedId.ToString());
		}

		#endregion

		#region Paging Data

		private void PageGrid(object obj, DataGridPageChangedEventArgs e)
		{
			DataGrid objSource = (DataGrid)obj;
			if(objSource.ID	== "GameVolunteersGrid")
			{
				GameVolunteersGrid.CurrentPageIndex = 0;
				VolGridUpdate(Convert.ToInt32(ViewState["GameId"])) ;
			}
			else
			{
				GameVolunteersGrid.CurrentPageIndex = 0;
				DateTime DateWorked = Convert.ToDateTime(DayList.SelectedItem.Text) ;
				GetDataGrid(DateWorked);
			}
		}

		private void SetPagerStats(string PagerName)
		{
			int pageCount;
			int currentPageIndex;

			if(PagerName == "Pager")
			{
				currentPageIndex = GameVolunteersGrid.CurrentPageIndex + 1;
				pageCount = GameVolunteersGrid.PageCount;

				CurrentPage.Text = currentPageIndex.ToString();
				PageCount.Text = pageCount.ToString();
			}
			else
			{
				currentPageIndex = TimeSheetDataGrid.CurrentPageIndex + 1;
				pageCount = TimeSheetDataGrid.PageCount;

				CurrentPage2.Text = currentPageIndex.ToString();
				PageCount2.Text = pageCount.ToString();
			}
		}

		private void Pager_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{			
			ImageButton objSender = (ImageButton)sender;
			switch(objSender.CommandArgument)
			{
				case "PREV":
					if(GameVolunteersGrid.CurrentPageIndex > 0)
						GameVolunteersGrid.CurrentPageIndex --;
					break;
				case "NEXT":
					if(GameVolunteersGrid.CurrentPageIndex < (GameVolunteersGrid.PageCount - 1))
						GameVolunteersGrid.CurrentPageIndex ++;
					break;
				case "GO":
					if((Convert.ToInt32(CurrentPage.Text) <= GameVolunteersGrid.PageCount) && (Convert.ToInt32(CurrentPage.Text) != 0))
					{
						GameVolunteersGrid.CurrentPageIndex = Convert.ToInt32(CurrentPage.Text) - 1;
					}
					break;
				case "FIRST":
					GameVolunteersGrid.CurrentPageIndex = 0;
					break;
				case "LAST":					
					GameVolunteersGrid.CurrentPageIndex = GameVolunteersGrid.PageCount - 1;
					break;
				case "PREV2":
					if(TimeSheetDataGrid.CurrentPageIndex > 0)
						TimeSheetDataGrid.CurrentPageIndex --;
					break;
				case "NEXT2":
					Page.Trace.Warn("PageCount", TimeSheetDataGrid.PageCount.ToString());
					Page.Trace.Warn("CurrentPage2", TimeSheetDataGrid.CurrentPageIndex.ToString());
					if(TimeSheetDataGrid.CurrentPageIndex < (TimeSheetDataGrid.PageCount - 1))
						TimeSheetDataGrid.CurrentPageIndex ++;

					
					Page.Trace.Warn("PageCount", TimeSheetDataGrid.PageCount.ToString());
					Page.Trace.Warn("CurrentPage2", TimeSheetDataGrid.CurrentPageIndex.ToString());
					break;
				case "GO2":
					if((Convert.ToInt32(CurrentPage2.Text) <= TimeSheetDataGrid.PageCount) && (Convert.ToInt32(CurrentPage2.Text) != 0))
					{
						TimeSheetDataGrid.CurrentPageIndex = Convert.ToInt32(CurrentPage2.Text) - 1;
					}
					break;
				case "FIRST2":
					TimeSheetDataGrid.CurrentPageIndex = 0;
					break;
				case "LAST2":					
					TimeSheetDataGrid.CurrentPageIndex = TimeSheetDataGrid.PageCount - 1;
					break;
			}

			if(objSender.CommandArgument.IndexOf("2", 0) == -1)
			{
				CurrentPage.Text = GameVolunteersGrid.CurrentPageIndex.ToString();
				VolGridUpdate(Convert.ToInt32(ViewState["GameId"].ToString())) ;
			}
			else
			{
				CurrentPage2.Text = TimeSheetDataGrid.CurrentPageIndex.ToString();
				GetDataGrid(Convert.ToDateTime(DayList.SelectedItem.Text)) ;
			}
		}
		#endregion


		#region Web Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.GamesList.EditCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.Register_Click);
			this.SearchButton.Click += new System.EventHandler(this.SearchButton_Click);
			this.ResetButton.Click += new System.EventHandler(this.ResetButton_Click);
			this.GameVolunteersGrid.PageIndexChanged += new System.Web.UI.WebControls.DataGridPageChangedEventHandler(this.PageGrid);
			this.GameVolunteersGrid.EditCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.VolGridEdit_Click);
			this.FIRST.Click += new System.Web.UI.ImageClickEventHandler(this.Pager_Click);
			this.Previous.Click += new System.Web.UI.ImageClickEventHandler(this.Pager_Click);
			this.GO.Click += new System.Web.UI.ImageClickEventHandler(this.Pager_Click);
			this.Next.Click += new System.Web.UI.ImageClickEventHandler(this.Pager_Click);
			this.LAST.Click += new System.Web.UI.ImageClickEventHandler(this.Pager_Click);
			this.DayList.SelectedIndexChanged += new System.EventHandler(this.GetTimeButton_Click);
			this.PostButton.Click += new System.EventHandler(this.PostButton_Click);
			this.DeleteButton.Click += new System.EventHandler(this.DeleteButton_Click);
			this.btnSearch.Click += new System.EventHandler(this.SearchButton_Click);
			this.btnReset.Click += new System.EventHandler(this.ResetButton_Click);
			this.TimeSheetDataGrid.PageIndexChanged += new System.Web.UI.WebControls.DataGridPageChangedEventHandler(this.PageGrid);
			this.TimeSheetDataGrid.SelectedIndexChanged += new System.EventHandler(this.EditButton_Click);
			this.FIRST2.Click += new System.Web.UI.ImageClickEventHandler(this.Pager_Click);
			this.PREV2.Click += new System.Web.UI.ImageClickEventHandler(this.Pager_Click);
			this.GO2.Click += new System.Web.UI.ImageClickEventHandler(this.Pager_Click);
			this.NEXT2.Click += new System.Web.UI.ImageClickEventHandler(this.Pager_Click);
			this.LAST2.Click += new System.Web.UI.ImageClickEventHandler(this.Pager_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

	}
}
