using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Text.RegularExpressions;
using System.Text;

using TimeKeeping = Vha.Vtk.TimeKeeping;
using Vha.Vtk.Common;
using Vha.Vtk.Kernel.Common;
using VTK.Utility;
using Vha.Vtk.WebControlLibrary;

namespace VTK.Games
{
	/// <summary>
	/// Summary description for VolunteerNewEdit.
	/// </summary>
	public class GamesVolunteerNewEdit : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Button PostButton;
		protected System.Web.UI.WebControls.Label ConfirmationMessage;
		protected System.Web.UI.WebControls.Label ErrorMessage;
		protected System.Web.UI.WebControls.TextBox PhoneText;
		protected System.Web.UI.WebControls.TextBox Phone1Text;
		protected System.Web.UI.WebControls.TextBox Phone2Text;
		protected System.Web.UI.WebControls.TextBox EMailText;
		protected System.Web.UI.WebControls.TextBox ZipText;
		protected System.Web.UI.WebControls.TextBox Address1Text;
		protected System.Web.UI.WebControls.TextBox Address2Text;
		protected System.Web.UI.WebControls.TextBox CityText;
		protected System.Web.UI.WebControls.DropDownList StateList;
		protected System.Web.UI.WebControls.Panel ContactPanel;
		protected Vha.Vtk.WebControlLibrary.VtkCompositeDate EntryDate;
		protected System.Web.UI.WebControls.TextBox LastNameText;
		protected System.Web.UI.WebControls.TextBox FirstNameText;
		protected System.Web.UI.WebControls.TextBox MiddleNameText;
		protected System.Web.UI.WebControls.TextBox NickNameText;
		protected System.Web.UI.WebControls.TextBox SSNText;
		protected System.Web.UI.WebControls.CheckBox PseudoCheckBox;
		protected Vha.Vtk.WebControlLibrary.VtkCompositeDate DateOfBirthDate;
		protected System.Web.UI.WebControls.RadioButtonList SexList;
		protected System.Web.UI.WebControls.Label StationLabel;
		protected System.Web.UI.WebControls.CheckBox VAEmployeeCheck;
		protected System.Web.UI.WebControls.DropDownList LanguageList;
		protected Vha.Vtk.WebControlLibrary.VtkPageHeader VtkPageHeader1;
	
		public GamesVolunteerNewEdit()
		{
			Page.Init += new System.EventHandler(Page_Init);
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			try
			{
				if (VtkPageHeader1.IsDivSelected("Registration"))
				{
					if (!Page.IsPostBack)
					{
						LastNameText.Text = string.Empty ;
						SSNText.Text = string.Empty ;
						string ssn = string.Empty ;
						//set year list
						DateOfBirthDate.YearListBegin = 1890 ;
						DateOfBirthDate.YearListEnd = DateTime.Now.Year ;
						DateOfBirthDate.InitializeControl() ;
						EntryDate.YearListBegin = 2000 ;
						EntryDate.YearListEnd = DateTime.Now.Year ;
						EntryDate.InitializeControl() ;
						//set entry date to today
						EntryDate.Date = DateTime.Today.Date ;

						//populate state list
						DataSet dsst = Vha.Vtk.Kernel.Data.SystemTables.State.GetQuickList() ;
						DataTable dtst = dsst.Tables["StateList"] ;
						dtst.DefaultView.Sort = "Abbreviation ASC" ;

						// insert a new row for the "not selected" item
						DataRow stdr = dtst.NewRow() ;
						stdr["Id"]=int.MinValue;
						stdr["Abbreviation"]="--";
						dtst.Rows.InsertAt(stdr,0);

						StateList.DataTextField = "Abbreviation" ;
						StateList.DataValueField = "Id" ;
						StateList.DataSource = dtst ;
						StateList.DataBind() ;
						dsst.Dispose() ;
						dtst.Dispose() ;

						//build language list
						DataSet dsL = Vha.Vtk.Kernel.Data.SystemTables.Language.GetQuickList() ;
						DataTable dtL = dsL.Tables["LanguageList"] ;
						LanguageList.DataTextField = "LanguageName" ;
						LanguageList.DataValueField = "ID" ;
						LanguageList.DataSource = dtL ;
						LanguageList.DataBind() ;
						dsL.Dispose() ;
						dtL.Dispose() ;
						
						//check for input parameter, these came from GamesRegistration
						ViewState["volId"] = string.Empty ;
						//check for input parameter, these came from VolunteerChooserNew, new volunteer
						if (Page.Request.QueryString.Count > 1)
						{
							if (Page.Request.QueryString["volName"] != null)
							{
								LastNameText.Text = Page.Request.QueryString["VolName"].ToString() ;
							}
							if (Page.Request.QueryString["volSSN"] != null)
							{
								SSNText.Text = Page.Request.QueryString["VolSSN"].ToString() ;
							}
							if (Page.Request.QueryString["GameId"] != null)
							{
								//these inputs come from query strings, these are the subordinate pages
								ViewState["GameId"] = Page.Request.QueryString["GameId"].ToString() ;
							}
							if (Page.Request.QueryString["HostStationId"] != null)
							{
								//these inputs come from query strings, these are the subordinate pages
								ViewState["HostStationId"] = Page.Request.QueryString["HostStationId"].ToString() ;
							}
							if (Page.Request.QueryString["HostName"] != null)
							{
								//these inputs come from query strings, these are the subordinate pages
								ViewState["HostStationName"] = Page.Request.QueryString["HostName"].ToString() ;
								StationLabel.Text = ViewState["HostStationName"].ToString() ;
							}
						}
					}
					//save the stationId on the form, used by exit button
					Page.RegisterHiddenField("StationId", VtkPageHeader1.DivSelectedId.ToString()) ;
				}
				else
				{ Response.Redirect("/Vtk/Welcome.aspx?" + VtkPageHeader.GetURLParameterString()+"=" + VtkPageHeader1.DivSelectedId) ;}
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Volunteer Record: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Volunteer Record: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Volunteer Record: " + err.Message) ;}
		}

		private string MissingFields()
		{
			string fields = string.Empty ;
			if (LastNameText.Text == string.Empty)
			{ fields = "Last Name, " ;}
			if (FirstNameText.Text == string.Empty)
			{ fields = fields + "First Name, " ;}
			if (SSNText.Text == string.Empty)
			{ fields = fields + "Social Security Number, " ;}
			if (DateOfBirthDate.Date == DateTime.MinValue)
			{ fields = fields + "Date Of Birth, " ;}
			if (SexList.SelectedIndex < 0)
			{ fields = fields + "Sex, " ;}
			if (EntryDate.Date == DateTime.MinValue)
			{ fields = fields + "Entry Date, " ;}
			if (Address1Text.Text == string.Empty)
			{ fields = fields + "Street Address #1, " ;}
			if (CityText.Text == string.Empty)
			{ fields = fields + "City, " ;}
			if (StateList.SelectedIndex < 0)
			{ fields = fields + "State, " ;}
			if (ZipText.Text == string.Empty)
			{ fields = fields + "Zip, " ;}

			return fields ;
		}

		private void PostButton_Click(object sender, System.EventArgs e)
		{
			//define handles
			Vha.Vtk.TimeKeeping.Volunteer volhdl = null ;
			Vha.Vtk.TimeKeeping.ContactInformation conhdl = null ;
			Vha.Vtk.TimeKeeping.StationProfile prohdl = null ;
			int volId = 0 ;
			string volName = string.Empty ;
			string siteId  = ViewState["HostStationId"].ToString() ;
			bool versionOk = true ;

			string missingdata = MissingFields() ;
			if (missingdata != string.Empty)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "The following fields are Required: " + missingdata) ;}
			else
			{
				try
				{
					//check if new or existing record
					if (ViewState["volId"].ToString() != string.Empty)
					{
						volId = Convert.ToInt32(ViewState["volId"].ToString()) ;
						volhdl = new Vha.Vtk.TimeKeeping.Volunteer(volId, VtkUtility.GetAppCon()) ;
						//check version
						if (ViewState["version"].ToString() != volhdl.Version.ToString())
						{
							VtkUtility.ErrMsgAdd(ErrorMessage, "Current Volunteer record has changed while you were editing, Please press EXIT and start over. ") ;
							versionOk = false ;
						}
					}
					else
					{
						//new record
						volhdl = Vha.Vtk.TimeKeeping.Volunteer.AddRecord() ;
					}
					if (versionOk)
					{
						//post values
						string ssn = SSNText.Text ;
						//if ssn contains dashes, remove
						if (Regex.IsMatch(ssn, @"^\d{3}-\d{2}-\d{4}"))
						{ ssn = ssn.Substring(0,3) + ssn.Substring(4,2) + ssn.Substring(7,4) ;}
						volhdl.SocialSecurityNumber = ssn ;
						volhdl.LastName = LastNameText.Text.ToString().Trim() ;
						volhdl.FirstName = FirstNameText.Text.ToString().Trim() ;
						volhdl.MiddleName = MiddleNameText.Text.ToString() ;
						volhdl.NickName = NickNameText.Text.ToString() ;
						volhdl.DateOfBirth = DateOfBirthDate.Date ;
						volhdl.IsVAEmployee = VAEmployeeCheck.Checked ;
						volhdl.PreferredLanguageForLoginId = Convert.ToInt32(LanguageList.SelectedItem.Value) ;

						if (PseudoCheckBox.Checked == true)
						{  volhdl.IsPseudoSSN = true ;}
						else
						{ volhdl.IsPseudoSSN = false ;}
						if (SexList.SelectedIndex == 0)
						{ volhdl.Sex = "M" ;}
						if (SexList.SelectedIndex == 1)
						{ volhdl.Sex = "F" ;}

						//new record
						conhdl = Vha.Vtk.TimeKeeping.ContactInformation.AddRecord() ;
						//save current fields
						conhdl.StreetAddress1 = Address1Text.Text ;
						conhdl.StreetAddress2 = Address2Text.Text ;
						conhdl.City = CityText.Text ;
						conhdl.ZipCode = ZipText.Text ;
						conhdl.Telephone = PhoneText.Text ;
						conhdl.AlternateTelephone = Phone1Text.Text ;
						conhdl.AlternateTelephone2 = Phone2Text.Text ;
						conhdl.EMailAddress = EMailText.Text ;
						if (StateList.SelectedIndex > -1)
						{ conhdl.StateId = Convert.ToInt32(StateList.SelectedItem.Value) ;}

						
						//create a station profile and file required fields
						prohdl = Vha.Vtk.TimeKeeping.StationProfile.AddRecord() ;
						prohdl.EntryDate = EntryDate.Date ;
						prohdl.StationId = Convert.ToInt32(siteId) ;
						prohdl.EligibleForMeals = 1 ;

						//save all 3 objects and returns the volunteer object
						ReturnStatus ret = null ;
						volId = Vha.Vtk.TimeKeeping.Volunteer.AddRecord(volhdl, conhdl, prohdl, out ret) ;

						//get volId & get values from volunteer object
						volhdl = new Vha.Vtk.TimeKeeping.Volunteer(volId, VtkUtility.GetAppCon()) ;

						//need volunteer name and id for navigation after posting
						volName = volhdl.FullNameForReports + " (" + volhdl.SocialSecurityNumber + ") " ;

						//clean up
						volhdl.Dispose() ;
						conhdl.Dispose() ;
						prohdl.Dispose() ;

						//navigate back to GamesVolunteerKinEdit
						StringBuilder sb = new StringBuilder("GamesVolunteerKinEdit.aspx") ;
						//add gamestation id
						sb.Append("?StationId=") ;
						sb.Append(VtkPageHeader1.DivSelectedId) ;
						//game Id
						sb.Append("&GameId=") ;
						sb.Append(ViewState["GameId"].ToString()) ;
						//host station Id
						sb.Append("&HostStationId=") ;
						sb.Append(siteId) ;
						//host station name
						sb.Append("&HostName=") ;
						sb.Append(ViewState["HostStationName"].ToString()) ;
						//add volunteer id
						sb.Append("&volId=") ;
						sb.Append(volId.ToString()) ;
						//add volunteer name
						sb.Append("&volName=") ;
						sb.Append(volName.ToString()) ;
						//add vol station id
						sb.Append("&volStId=") ;
						sb.Append(siteId) ;
						Response.Redirect(sb.ToString()) ;
					}
				}
				catch (VhaValidationException valErr)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error posting the Volunteer Record: " + valErr.Message) ;}
				catch (VhaTransactionException transErr)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error posting the Volunteer Record: " + transErr.Message) ;}
				catch (Exception err)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error posting the Volunteer Record: " + err.Message) ;}
			}
		}

		private void ExitButton_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("../Index.aspx?" + VtkPageHeader.GetURLParameterString() + "=" + VtkPageHeader1.DivSelectedId.ToString());
		}

		private void Page_Init(object sender, EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
		}

		#region Web Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
					private void InitializeComponent()
					{    
						this.PostButton.Click += new System.EventHandler(this.PostButton_Click);
						this.Load += new System.EventHandler(this.Page_Load);

					}
		#endregion

	}
}
