<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
								xmlns:msxsl="urn:schemas-microsoft-com:xslt" 
								xmlns:user="http://userns" 
								xmlns:security="urn:security"
								version="1.0" 
								exclude-result-prefixes="#default msxsl user">
	<xsl:output omit-xml-declaration="yes" 
						  method="html" 
						  indent="yes"/>
	<xsl:param name="StationId"/>
	<xsl:param name="activepage"/>				
	<msxsl:script  language="C#" implements-prefix="user">
		int tabIndex = 0;
		public string GetTabIndex()
		{
			return tabIndex.ToString();
		}
		public string GetNewTabIndex()
		{
			tabIndex++;
			return tabIndex.ToString();
		}
		
		int globalID = 0;
		public string GetID()
		{			
			return globalID.ToString();
		}
		public string GetNewID()
		{
			globalID++;			
			return globalID.ToString();
		}
		public string GetLength(XPathNodeIterator node)
	  {
	    XPathNavigator xNode = node.Current;	      
			return xNode.GetAttribute("DisplayText", null);
	  }
	</msxsl:script>
	<xsl:variable name="Navigation.Images.List">
		<Images type="line">
			<Image name="line.gif" id=""/>
		</Images>
		<!-- Join Images (basically for MenuItems)-->
		<Images type="join">
			<Image name="jointop.gif" id="0010"/>
			<Image name="joinbottom.gif" id="1100"/>
			<Image name="joinbottom.gif" id="0100"/>
			<Image name="joinbottom.gif" id="1000"/>
			<Image name="join.gif" id="1110"/>
			<Image name="join.gif" id="1010"/>
			<Image name="join.gif" id="0110"/>
		</Images>
		<!-- Minus Images -->
		<Images type="minus">
			<Image name="minusonly.gif" id="0001"/>
			<Image name="minustop.gif" id="0011"/>
			<Image name="minusbottom.gif" id="1101"/>
			<Image name="minusbottom.gif" id="0101"/>
			<Image name="minusbottom.gif" id="1001"/>
			<Image name="minus.gif" id="1111"/>
			<Image name="minus.gif" id="0111"/>
			<Image name="minus.gif" id="1011"/>
		</Images>
		<!-- Plus Images -->
		<Images type="plus">
			<Image name="plusonly.gif" id="0001"/>
			<Image name="plustop.gif" id="0011"/>
			<Image name="plusbottom.gif" id="1101"/>
			<Image name="plusbottom.gif" id="0101"/>
			<Image name="plusbottom.gif" id="1001"/>
			<Image name="plus.gif" id="1111"/>
			<Image name="plus.gif" id="0111"/>
			<Image name="plus.gif" id="1011"/>
		</Images>
	</xsl:variable>
	<xsl:variable name="Navigation.Images" select="msxsl:node-set($Navigation.Images.List)"/>
	
	<xsl:template match="/">
		<DIV Class="ParentDiv">
		<Div Class="MenuHeader">
			VSS Help
		</Div>
			<xsl:apply-templates select="doc/child::node()" />
		</DIV>
	</xsl:template>
	<xsl:template match="node()">
		<xsl:if test="local-name()!='MenuItem'">
		<Div id="{user:GetNewID()}" Class="MenuSection" border="0" TABINDEX="{user:GetNewTabIndex()}" NOWRAP="TRUE">
			<xsl:if test="//MenuItem[contains(./@URL, $activepage)]">
				<xsl:attribute name="style">display: inline;</xsl:attribute>
			</xsl:if>
			<Div Id="{user:GetNewID()}" Class="MenuImages">
				<xsl:call-template name="navimage.choose">						
					<xsl:with-param name="hasParent">
						<xsl:choose>
							<xsl:when test="count(parent::node()[name()='doc']) = 0">1</xsl:when>
							<xsl:otherwise>0</xsl:otherwise>
						</xsl:choose>
					</xsl:with-param>
					<xsl:with-param name="hasPrecedingSibling">
						<xsl:choose>
							<xsl:when test="count(preceding-sibling::node()[name()='MenuSection' or name()='MenuSubSection']) != 0">1</xsl:when>
							<xsl:otherwise>0</xsl:otherwise>
						</xsl:choose>
					</xsl:with-param>
					<xsl:with-param name="hasFollowingSibling">
						<xsl:choose>
							<xsl:when test="count(following-sibling::node()[name()='MenuSection' or name()='MenuSubSection']) != 0">1</xsl:when>
							<xsl:otherwise>0</xsl:otherwise>
						</xsl:choose>
					</xsl:with-param>
					<xsl:with-param name="hasChildren">
						<xsl:choose>
							<xsl:when test="count(child::node()) != 0">1</xsl:when>
							<xsl:otherwise>0</xsl:otherwise>
						</xsl:choose>
					</xsl:with-param>
				</xsl:call-template>
				<img Id="TypeImage{user:GetID()}" Class="TypeImage" src="../images/menu/helpclosed.gif" align="absmiddle">							
					<xsl:attribute name="ID"><xsl:value-of select="user:GetID()"/>F</xsl:attribute>
				</img>		
				<xsl:value-of select="@DisplayText"/>
			</Div>
			<xsl:if test="count(./node()) != 0">
				<DIV Id="MenuDivIndent{user:GetID()}" CLASS="MenuDivIndent" NOWRAP="True" style="display: none;" valign="absmiddle">
					<xsl:apply-templates select="./node()[name()='MenuSection' or name()='MenuSubSection']"/>
					<xsl:for-each select="./node()[name()='MenuItem']">						
			   			<xsl:call-template name="MenuItem"/>
					</xsl:for-each>						
				</DIV>
			</xsl:if>				
		</Div>	
		</xsl:if>
	</xsl:template>	
	
	<!-- ****************************************************** -->
	<!--							MenuItem Template for individual menu items             -->
	<!-- ****************************************************** -->
	<xsl:template name="MenuItem">
		<Div Class="MenuItem" NoWrap="true" align="middle">
		<xsl:call-template name="navimage.choose">						
			<xsl:with-param name="hasParent">
					<xsl:choose>
						<xsl:when test="count(parent::node()[name()='doc']) = 0">1</xsl:when>
						<xsl:otherwise>0</xsl:otherwise>
					</xsl:choose>
				</xsl:with-param>
				<xsl:with-param name="hasPrecedingSibling">
					<xsl:choose>
						<xsl:when test="count(preceding-sibling::node()[name()='MenuSection' or name()='MenuSubSection' or name()='MenuItem']) != 0">1</xsl:when>
						<xsl:otherwise>0</xsl:otherwise>
					</xsl:choose>
				</xsl:with-param>
				<xsl:with-param name="hasFollowingSibling">
					<xsl:choose>
						<xsl:when test="count(following-sibling::node()[name()='MenuSection' or name()='MenuSubSection' or name()='MenuItem']) != 0">1</xsl:when>
						<xsl:otherwise>0</xsl:otherwise>
					</xsl:choose>
				</xsl:with-param>
				<xsl:with-param name="hasChildren">0</xsl:with-param>
			</xsl:call-template>
			<img Id="TypeImage{user:GetID()}" Class="TypeImage" src="../images/menu/helppage.gif" align="absmiddle">
				<xsl:attribute name="src">
					<xsl:choose>
						<xsl:when test="@Image != ''">
							<xsl:value-of select="@Image"/>
						</xsl:when>
						<xsl:otherwise>
							../images/menu/helppage.gif
						</xsl:otherwise>
					</xsl:choose>
				</xsl:attribute>
			</img>
			<a class="MenuItemLink" href="{@URL}" title="{@Title}" TABINDEX="{user:GetNewTabIndex()}" target="main"><xsl:value-of select="@DisplayText"/></a>
		</Div>
	</xsl:template>
	
	<xsl:template name="navimage.choose">
		<xsl:param name="hasParent"/>
		<xsl:param name="hasPrecedingSibling"/>
		<xsl:param name="hasFollowingSibling"/>
		<xsl:param name="hasChildren"/>
		<xsl:variable name="type">
			<xsl:choose>
				<xsl:when test="$hasChildren != 0">plus</xsl:when>
				<xsl:otherwise>join</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="ImageId">
			<xsl:value-of select="$Navigation.Images/Images[@type=$type]/Image[@id=concat($hasParent, $hasPrecedingSibling, $hasFollowingSibling, $hasChildren)]/@name"/>
		</xsl:variable>		
		<IMG Id="NavImage{user:GetID()}" CLASS="NavImage" align="absmiddle"><xsl:attribute name="src">../images/menu/<xsl:value-of select="$ImageId"/></xsl:attribute></IMG>	
	</xsl:template>
</xsl:stylesheet>