using System;
using System.Collections;
using System.Configuration;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Security.Principal;
//using Microsoft.eSupport.Security;
using System.Xml;
using System.Xml.XPath;
using System.Xml.Xsl;
using Vha.Vss.Utility;
using Vha.Vss.Security;
using Vha.Vtk.Kernel.Common;
using Vha.Vtk;

namespace VTK
{
	/// <summary>
	/// Summary description for Menu.
	/// </summary>
	public class Menu : System.Web.UI.Page
	{
		const string URLPARAMETER="StationId";
		private XmlDocument XmlDivisionList;
		private XmlDocument XmlSecurity;
		private Security UISecurity;
		private IDictionary config;
		private string StationId;
		public string XmlMenu;
		protected XmlDocument m_XUser;
		protected XmlNode m_XmlUserName;

		public Menu(){}
    
		private void Page_Load(object sender, System.EventArgs e)
		{  
			string ServerPath = Server.MapPath("");
			try
			{
				config = (IDictionary)ConfigurationSettings.GetConfig("VssConfiguration/Application");
			}
			catch{}
			string DivisionList;
			//Load the Menu Security Definition			
			XmlSecurity = new XmlDocument();
			XmlSecurity.Load((string)config["Security"]);

			//Get the User Security Context
			XmlDivisionList = new XmlDocument();
			String Auth_User = Page.Request.ServerVariables.Get("AUTH_USER");
			XmlDivisionList = ApplicationConnection.GetXmlDivisionList(Auth_User);
			DivisionList = XmlDivisionList.OuterXml;
			

			//Get the current selected StationId if there is one.
			if (Page.Request.QueryString[URLPARAMETER] != null)
				StationId = Page.Request.QueryString[URLPARAMETER];
			else if(XmlDivisionList.DocumentElement.Attributes.GetNamedItem("DefaultDivision") != null)
				StationId = XmlDivisionList.DocumentElement.Attributes.GetNamedItem("DefaultDivision").Value;
			else if(XmlDivisionList.DocumentElement.ChildNodes.Count > 0)
				StationId = XmlDivisionList.DocumentElement.ChildNodes[0].Attributes.GetNamedItem("Id").Value;
			else
				throw new Exception("No StationId present and no Divisions are assigned to this user.");

			//Create the Security Object for the XSLT
			Page.Trace.Warn("Security Path", (string)config["Security"]);
			Page.Trace.Warn("Station ID", StationId);
			Page.Trace.Warn("XmlDivisionList", XmlDivisionList.OuterXml);
			Page.Trace.Warn("XmlSecurity", XmlSecurity.OuterXml);

			UISecurity = new Security(XmlSecurity, XmlDivisionList, StationId);
			
			XmlDocument SecureDoc = new XmlDocument();
			XmlTransformer preTransformer = new XmlTransformer();
			preTransformer.XsltArguments.AddParam("StationId", "", StationId.ToString());
			preTransformer.XsltArguments.AddExtensionObject("urn:security", UISecurity);
			preTransformer.Transform(SecureDoc, ServerPath + "/Xml/VssMenu.xml", ServerPath + "/Xml/MenuXmlToXml.xslt");

			Page.Trace.Warn("Security Filter Output", SecureDoc.OuterXml);	

			XmlTransformer myTransformer = new XmlTransformer();
			myTransformer.XsltArguments.AddParam("StationId", "", StationId.ToString());
			myTransformer.XmlDataSourceParms.XmlDocumentObject = SecureDoc;
			myTransformer.XslDataSourceParms.Filename = ServerPath + "/Xml/MenuXmlToHtml.xslt";
			XmlMenu = myTransformer.Transform();		
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
