using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Text;

using Vha.Vtk.Common;
using Vha.Vtk.Kernel.Common;
using VTK.Utility;
using Vha.Vtk.WebControlLibrary;
using Vha.Vtk.Donations;
using Vha.Vtk.TimeKeeping;

namespace VTK.National
{
	/// <summary>
	/// Summary description for ReportsVolunteersByOrganizationDataView.
	/// </summary>
	public class ReportsVolunteersByOrganizationDataView : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label ErrorMessage;
		protected System.Web.UI.WebControls.Label KeyLabel;
		protected System.Web.UI.WebControls.DataGrid DataGrid;
		protected System.Web.UI.WebControls.Label NotesLabel;
		protected Vha.Vtk.WebControlLibrary.VtkPageHeader VtkPageHeader1;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			try
			{
				if (VtkPageHeader1.IsDivSelected("Volunteers By Organization Data View"))
				{
					if (!Page.IsPostBack)
					{
						// get parameters and build data grid
						string orglist = Request.QueryString["orglist"];
						DateTime begindate = Convert.ToDateTime(Request.QueryString["begindate"]);
						DateTime enddate = Convert.ToDateTime(Request.QueryString["enddate"]);
						UpdateDataGrid(orglist, begindate, enddate);
						//set key box
						KeyLabel.Text = "Begin Date = " + begindate.ToShortDateString() + "    End Date = " + enddate.ToShortDateString();
					}
					//save the stationId on the form
					Page.RegisterHiddenField("StationId", VtkPageHeader1.DivSelectedId.ToString()) ;
					
				}
				else
				{ Response.Redirect("/Vtk/Welcome.aspx?" + VtkPageHeader.GetURLParameterString()+"=" + VtkPageHeader1.DivSelectedId) ;}
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Volunteers By Organization Data: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Volunteers By Organization Data: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Volunteers By Organization Data: " + err.Message) ;}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void UpdateDataGrid(string orglist, System.DateTime begindate, System.DateTime enddate)
		{
			DataSet dsData;
			DataTable dtData;
			string displayName = string.Empty ;
			string error = "";
			if (error != string.Empty)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, error) ;}
			else
			{
				//get the data for the report
				dsData = Vha.Vtk.TimeKeeping.VolunteerHours.GetQuickListDataForVolByOrgReport(orglist, begindate, enddate);
				dtData = dsData.Tables["GetQuickListDataForVolByOrgReport"];
				
				DataGrid.DataSource = dtData;
				DataGrid.DataBind();

				dsData.Dispose();
				dtData.Dispose();

			}
		}
	}
}
