using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using Vha.Vtk.WebControlLibrary;
using VTK.Utility;
using System.Text;

namespace VTK.Reports
{
	/// <summary>
	/// Summary description for Reports.
	/// </summary>
	public class Reports : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label ErrorMessage;
		protected System.Web.UI.WebControls.HyperLink PotentialAwards;
		protected System.Web.UI.WebControls.HyperLink RSVolunteersMonthly;
		protected System.Web.UI.WebControls.HyperLink SignedIn;
		protected System.Web.UI.WebControls.HyperLink Telephone;
		protected System.Web.UI.WebControls.HyperLink HoursByOrganization;
		protected System.Web.UI.WebControls.HyperLink AddressLabels;
		protected System.Web.UI.WebControls.HyperLink Annual;
		protected System.Web.UI.WebControls.HyperLink AlphabeticalVolunteers;
		protected System.Web.UI.WebControls.HyperLink OHRptSelectedOrg;
		protected System.Web.UI.WebControls.HyperLink OHRpt;
		protected System.Web.UI.WebControls.HyperLink StationInformationContactList;
		protected System.Web.UI.WebControls.HyperLink ProgramsSupervised;
		protected System.Web.UI.WebControls.HyperLink StationInformation;
		protected System.Web.UI.WebControls.HyperLink DirectoryLabels;
		protected System.Web.UI.WebControls.HyperLink ServiceDirectory;
		protected System.Web.UI.WebControls.HyperLink Labels;
		protected System.Web.UI.WebControls.HyperLink AJR;
		protected System.Web.UI.WebControls.HyperLink ServiceChiefs;
		protected System.Web.UI.WebControls.HyperLink AnnualJointReview;
		protected System.Web.UI.WebControls.HyperLink MailingLabels;
		protected System.Web.UI.WebControls.HyperLink MealTicket;
		protected Vha.Vtk.WebControlLibrary.VtkPageHeader VtkPageHeader1;
	
		public Reports()
		{
			Page.Init += new System.EventHandler(Page_Init);
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			try 
			{
				if (VtkPageHeader1.IsDivSelected()) 
				{
					//add the div parameter to all hyperlinks
					StringBuilder sb = new StringBuilder("?");
					sb.Append(VtkPageHeader.GetURLParameterString());
					sb.Append("=");
					sb.Append(VtkPageHeader1.DivSelectedId);
					string param = sb.ToString();
					AddressLabels.NavigateUrl+=param;
					AlphabeticalVolunteers.NavigateUrl+=param;
					Annual.NavigateUrl+=param;
					OHRpt.NavigateUrl+=param;;
					OHRptSelectedOrg.NavigateUrl+=param;;
					PotentialAwards.NavigateUrl += param ;
					RSVolunteersMonthly.NavigateUrl += param ;
					SignedIn.NavigateUrl += param ;
					Telephone.NavigateUrl += param;
					HoursByOrganization.NavigateUrl += param;
					MealTicket.NavigateUrl += param;
					// voluntary service directory reports
					DirectoryLabels.NavigateUrl += param;
					ProgramsSupervised.NavigateUrl += param;
					ServiceChiefs.NavigateUrl += param;
					ServiceDirectory.NavigateUrl += param;
					StationInformation.NavigateUrl += param;
					StationInformationContactList.NavigateUrl += param;
					// national officials reports
					AnnualJointReview.NavigateUrl += param;
					MailingLabels.NavigateUrl += param;

				}
			} 
			catch (Exception err) 
			{
				VtkUtility.ErrMsgAdd(ErrorMessage,err.Message);
			}
			// Put user code to initialize the page here
		}

		private void Page_Init(object sender, EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
		}

		#region Web Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void PageHeader_Click(object sender, System.EventArgs e)
		{
		
		}

	}
}
