using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using Vha.Vtk;
using Vha.Vtk.TimeKeeping;
using Vha.Vtk.Common;
using Vha.Vtk.Kernel.Common;
using VTK.Utility;
using Vha.Vtk.Donations;

namespace VTK.Utility
{
	/// <summary>
	/// Summary description for WriteSchema.
	/// </summary>
	public class WriteSchema : System.Web.UI.Page
	{
		public WriteSchema()
		{
			Page.Init += new System.EventHandler(Page_Init);
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here

			Table myTable = new Table();
			Page.Controls.Add(myTable);
			SelectCriteria sc = new SelectCriteria() ;
			sc.StartsWith = "smi" ;
			sc.MaxRecords = 50 ;
			DateTime dt = DateTime.Now ;

/*			Vha.Vtk.TimeKeeping.VolunteerHours.GetQuickListServicesOccRSHours(2003, 12).WriteXmlSchema(@"c:\temp\VtkTimeKeepingVolunteerHoursServicesOccRSHours.xml");
			AddHyperLink(@"c:\temp\VtkTimeKeepingVolunteerHoursServicesOccRSHours.xml","Vtk.TimeKeeping.VolunteerHours.VtkTimeKeepingVolunteerHoursServicesOccRSHours", myTable) ;

			Vha.Vtk.TimeKeeping.VolunteerAdjustments.GetQuickList(1, VtkUtility.GetAppCon()).WriteXmlSchema(@"c:\temp\VtkTimeKeepingAdjustmentGetQuickList.xml");
			AddHyperLink(@"c:\temp\VtkTimeKeepingAdjustmentGetQuickList.xml","Vtk.TimeKeeping.VolunteerAdjustment.GetList", myTable) ;

			Vha.Vtk.Kernel.Data.SystemTables.Language.GetQuickList().WriteXmlSchema(@"c:\temp\VtkLanguageGetQuickList.xml");
			AddHyperLink(@"c:\temp\VtkLanguageGetQuickList.xml","Kernel.Language.GetQuickList", myTable) ;

			Vha.Vtk.Games.GamesSchedule.GetQuickList().WriteXmlSchema(@"c:\temp\VtkGameGamesScheduleGetQuickList.xml");
			AddHyperLink(@"c:\temp\VtkGameGamesScheduleGetQuickList.xml","Game.Games.GetQuickList", myTable) ;

			Vha.Vtk.Games.GamesSchedule.GetQuickListByGamesTypeId(1).WriteXmlSchema(@"c:\temp\VtkGameGamesScheduleGetQuickListByGameType.xml");
			AddHyperLink(@"c:\temp\VtkGameGamesScheduleGetQuickListByGameType.xml","Game.Games.GetQuickListByGameType", myTable) ;

			Vha.Vtk.Games.GamesSchedule.GetQuickListByInstitutionId(1).WriteXmlSchema(@"c:\temp\VtkGameGamesScheduleGetQuickListByInst.xml");
			AddHyperLink(@"c:\temp\VtkGameGamesScheduleGetQuickListByInst.xml","VtkGameGamesScheduleGetQuickListByInst", myTable) ;

			Vha.Vtk.Games.GamesRegistration.GetQuickList().WriteXmlSchema(@"c:\temp\VtkGameGamesRegistrationGetQuickList.xml");
			AddHyperLink(@"c:\temp\VtkGameGamesRegistrationGetQuickList.xml","Game.GamesRegistration.GetQuickList", myTable) ;

			Vha.Vtk.Games.GamesRegistration.GetQuickListByGameSchedule(1).WriteXmlSchema(@"c:\temp\VtkGameGamesRegistrationGetQuickListByGameSchedule.xml");
			AddHyperLink(@"c:\temp\VtkGameGamesRegistrationGetQuickListByGameSchedule.xml","Game.GamesRegistration.GetQuickListByGameSchedule", myTable) ;

			Vha.Vtk.NationalOfficials.NACStatus.GetNacStatusList().WriteXmlSchema(@"c:\temp\VtkNationalOfficialsNACStatusQuickList.xml");
			AddHyperLink(@"c:\temp\VtkNationalOfficialsNACStatusQuickList.xml","Vtk.NationalOfficials.NACStatusQuickList", myTable) ;

			Vha.Vtk.NationalOfficials.NationalOfficials.GetQuickList().WriteXmlSchema(@"c:\temp\VtkNationalOfficialsQuickList.xml");
			AddHyperLink(@"c:\temp\VtkNationalOfficialsQuickList.xml","Vtk.NationalOfficials.QuickList", myTable) ;

			Vha.Vtk.MealTickets.MealsProvided.GetMonthsList().WriteXmlSchema(@"c:\temp\VtkMealTicketGetMonthsList.xml");
			AddHyperLink(@"c:\temp\VtkMealTicketGetMonthsList.xml","Vtk.MealTicket.GetMonthsList", myTable) ;

			Vha.Vtk.MealTickets.MealsProvided.GetMealTicketList(dt, 1, 1, int.MinValue).WriteXmlSchema(@"c:\temp\VtkMealTicketGetMealList.xml");
			AddHyperLink(@"c:\temp\VtkMealTicketGetMealList.xml","Vtk.MealTicket.GetMealList", myTable) ;

			Vha.Vtk.Common.Organization.GetSiteActiveQuickListByName(1).WriteXmlSchema(@"c:\temp\VtkCommonOrganizationQuickListByName.xml");
			AddHyperLink(@"c:\temp\VtkCommonOrganizationQuickListByName.xml","Vtk.Common.Organization.GetSiteActiveListByName", myTable);

			Vha.Vtk.Common.Organization.GetSiteActiveQuickListByCode(1).WriteXmlSchema(@"c:\temp\VtkCommonOrganization.xml");
			AddHyperLink(@"c:\temp\VtkCommonOrganization.xml","Vtk.Common.Organization.GetSiteActiveListByCode", myTable);

			Vha.Vtk.Common.Organization.GetOrganizationsQuickList(1).WriteXmlSchema(@"c:\temp\VtkCommonOrganizationQuickList.xml");
			AddHyperLink(@"c:\temp\VtkCommonOrganizationQuickList.xml","Vtk.Common.Organization.GetOrganizationQuickList", myTable);

			Vha.Vtk.TimeKeeping.VolunteerHours.GetQuickListForStationForDate(1, dt, false).WriteXmlSchema(@"c:\temp\VtkTimeKeepingVolunteerHoursListByStationByDate.xml");
			AddHyperLink(@"c:\temp\VtkTimeKeepingVolunteerHoursListByStationByDate.xml","Vtk.TimeKeeping.VolunteerHours.ListByStationByDate", myTable);

			Vha.Vtk.TimeKeeping.VolunteerHours.GetQuickListForGamesByVolunteer(1, dt, dt, "S").WriteXmlSchema(@"c:\temp\VtkTimeKeepingVolunteerHoursListForGamesByVol.xml");
			AddHyperLink(@"c:\temp\VtkTimeKeepingVolunteerHoursListForGamesByVol.xml","Vtk.TimeKeeping.VolunteerHours.ListForGamesByVol", myTable);

			Vha.Vtk.ServicesDirectory.ServiceStaff.GetQuickListByInstitutionId(1, VtkUtility.GetAppCon()).WriteXmlSchema(@"c:\temp\VtkServiceDirectoryServiceStaffByInstitution.xml");
			AddHyperLink(@"c:\temp\VtkServiceDirectoryServiceStaffByInstitution.xml", "Vtk.ServiceDirectory.ServiceStaff.GetQuickListByInstitution", myTable) ;

			Vha.Vtk.ServicesDirectory.StaffTitle.GetQuickList(1, VtkUtility.GetAppCon()).WriteXmlSchema(@"c:\temp\VtkServiceDirectoryStaffTitles.xml");
			AddHyperLink(@"c:\temp\VtkServiceDirectoryStaffTitles.xml","Vtk.ServiceDirectory.StaffTitles.GetQuickList", myTable);

			Vha.Vtk.ServicesDirectory.ServiceType.GetQuickList(VtkUtility.GetAppCon()).WriteXmlSchema(@"c:\temp\VtkServiceDirectoryServiceType.xml");
			AddHyperLink(@"c:\temp\VtkServiceDirectoryServiceType.xml","Vtk.ServiceDirectory.ServiceType.GetQuickList", myTable);

			Vha.Vtk.ServicesDirectory.Programs.GetVoluntaryPrograms(1, VtkUtility.GetAppCon()).WriteXmlSchema(@"c:\temp\VtkServiceDirectoryProgramsGetVoluntary.xml");
			AddHyperLink(@"c:\temp\VtkServiceDirectoryProgramsGetVoluntary.xml","Vtk.ServiceDirectory.Programs.GetVoluntaryPrograms", myTable);

			Vha.Vtk.Common.Service.GetSiteQuickListByName(1).WriteXmlSchema(@"c:\temp\VtkCommonServiceGetListByName.xml");
			AddHyperLink(@"c:\temp\VtkCommonServiceGetListByName.xml","Vtk.Common.Service.GetListByName", myTable);

			Vha.Vtk.Common.Service.GetQuickListForGames().WriteXmlSchema(@"c:\temp\VtkCommonServiceGetListForGames.xml");
			AddHyperLink(@"c:\temp\VtkCommonServiceGetListForGames.xml","Vtk.Common.Service.GetListForGames", myTable);

			Vha.Vtk.ServicesDirectory.SupervisedPrograms.GetQuickListByInstitutionId(1, VtkUtility.GetAppCon()).WriteXmlSchema(@"c:\temp\VtkServiceDirectorySupervisedPrograms.xml");
			AddHyperLink(@"c:\temp\VtkServiceDirectorySupervisedPrograms.xml","Vtk.ServiceDirectory.SupervisedPrograms.GetQuickList", myTable);

			Vha.Vtk.Kernel.Data.SystemTables.AdministrativeUnit.GetQuickList().WriteXmlSchema(@"c:\temp\VtkKernelSystemTablesAdministrativeUnit.xml");
			AddHyperLink(@"c:\temp\VtkKernelSystemTablesAdministrativeUnit.xml","Vtk.Kernel.Table.AdministrativeUnit.GetQuickList", myTable);

			Vha.Vtk.Kernel.Data.SystemTables.Institution.GetQuickList().WriteXmlSchema(@"c:\temp\VtkKernelSystemTablesInstitution.xml");
			AddHyperLink(@"c:\temp\VtkKernelSystemTablesInstitution.xml","Vtk.Kernel.Table.Institution.GetQuickList", myTable);
			
			Vha.Vtk.Kernel.Data.SystemTables.State.GetQuickList().WriteXmlSchema(@"c:\temp\VtkKernelSystemTablesState.xml");
			AddHyperLink(@"c:\temp\VtkKernelSystemTablesState.xml","Vtk.Kernel.Table.State.GetQuickList", myTable);

			Vha.Vtk.Kernel.Data.SystemTables.Institution.GetQuickListByVISN(1).WriteXmlSchema(
				"c:\\temp\\VtkKernelDataSystemTablesInstitutionQuickListByVISN.xml");
			AddHyperLink("c:\\temp\\VtkKernelDataSystemTablesInstitutionQuickListByVISN.xml","Vtk.Kernel.Data.SystemTables.Institution.QuickListByVISN", myTable);

			Vha.Vtk.ServicesDirectory.Programs.GetVoluntaryPrograms(int.MinValue, VtkUtility.GetAppCon()).WriteXmlSchema("c:\\temp\\VtkServiceDirectoryPrograms.xml") ;
			AddHyperLink("c:\\temp\\VtkServiceDirectoryPrograms.xml","Vtk.ServiceDirectory.Programs.GetQuickList", myTable) ;

			Vha.Vtk.Kernel.Data.SystemTables.UserRole.GetUserRoleAtSites("VHAMASTER\\ZZZZZZDIMICR", VtkUtility.GetAppCon()).WriteXmlSchema("c:\\temp\\VtkKernelUserRole.xml");
			AddHyperLink("c:\\temp\\VtkKernelUserRole.xml","Vtk.Kernel.UserRole", myTable) ;

			Vha.Vtk.Kernel.Data.SystemTables.UserRole.GetUserRolesAtSite(3, 3).WriteXmlSchema(@"c:\temp\VtkKernelUserRoleNew.xml");
			AddHyperLink(@"c:\temp\VtkKernelUserRoleNew.xml","Vtk.Kernel.UserRoleNew", myTable) ;

			Vha.Vtk.Kernel.Data.SystemTables.Role.GetQuickList().WriteXmlSchema(@"c:\temp\VtkKernelRoles.xml");
			AddHyperLink(@"c:\temp\VtkKernelRoles.xml","Vtk.Kernel.Roles", myTable) ;

			Vha.Vtk.Kernel.Data.SystemTables.User.GetQuickListByInstitutionId(3).WriteXmlSchema("c:\\temp\\VtkKernelUserQuickListBySite.xml");
			AddHyperLink("c:\\temp\\VtkKernelUserQuickListBySite.xml","Vtk.Kernel.User.ListBySite", myTable) ;

			Vha.Vtk.Kernel.Data.SystemTables.User.GetQuickList().WriteXmlSchema("c:\\temp\\VtkKernelUserQuickList.xml");
			AddHyperLink("c:\\temp\\VtkKernelUserQuickList.xml","Vtk.Kernel.User.QuickList", myTable) ;

			Vha.Vtk.TimeKeeping.Volunteer.GetVolunteerList(sc, 1, VtkUtility.GetAppCon()).WriteXmlSchema(@"c:\temp\VtkTimeKeepingVolunteerGetQuickList.xml");
			AddHyperLink(@"c:\temp\VtkTimeKeepingVolunteerGetQuickList.xml","Vtk.TimeKeeping.Volunteer.GetList", myTable) ;

			Vha.Vtk.TimeKeeping.Volunteer.GetVolunteerList(sc, VtkUtility.GetAppCon()).WriteXmlSchema(@"c:\temp\VtkTimeKeepingVolunteerGetQuickListNostation.xml");
			AddHyperLink(@"c:\temp\VtkTimeKeepingVolunteerGetQuickListNostation.xml","Vtk.TimeKeeping.Volunteer.GetListNostation", myTable) ;

			Vha.Vtk.TimeKeeping.Volunteer.GetVolunteerListBySSN("abc").WriteXmlSchema(@"c:\temp\VtkTimeKeepingVolunteerGetQuickListBySSN.xml");
			AddHyperLink(@"c:\temp\VtkTimeKeepingVolunteerGetQuickListBySSN.xml","Vtk.TimeKeeping.Volunteer.GetListBySSN", myTable) ;

			Vha.Vtk.TimeKeeping.Volunteer.GetVolunteerListByIdentifierCode("abc", true).WriteXmlSchema(@"c:\temp\VtkTimeKeepingVolunteerGetListByCode.xml");
			AddHyperLink(@"c:\temp\VtkTimeKeepingVolunteerGetListByCode.xml","Vtk.TimeKeeping.Volunteer.GetListByCode", myTable) ;

			Vha.Vtk.TimeKeeping.StationProfile.GetQuickList(1).WriteXmlSchema(@"c:\temp\VtkTimeKeepingStationProfileListById.xml");
			AddHyperLink(@"c:\temp\VtkTimeKeepingStationProfileListById.xml","Vtk.TimeKeeping.StationProfile.ListById", myTable) ;

			Vha.Vtk.TimeKeeping.StationProfile.GetQuickListByVolAndSite(1,1).WriteXmlSchema(@"c:\temp\VtkTimeKeepingStationProfileListByVolandSite.xml");
			AddHyperLink(@"c:\temp\VtkTimeKeepingStationProfileListByVolandSite.xml","Vtk.TimeKeeping.StationProfile.ListByVolAndSite", myTable) ;

			Vha.Vtk.TimeKeeping.StationProfile.GetQuickListByVol(1).WriteXmlSchema(@"c:\temp\VtkTimeKeepingStationProfileListByVol.xml");
			AddHyperLink(@"c:\temp\VtkTimeKeepingStationProfileListByVol.xml","Vtk.TimeKeeping.StationProfile.ListByVol", myTable) ;

			Vha.Vtk.Donations.Donor.GetQuickListBy_StationId_LastName(1, "J").WriteXmlSchema(@"c:\temp\VtkDonorListByStationLastName.xml");
			AddHyperLink(@"c:\temp\VtkDonorListByStationLastName.xml","Vtk.Donations.Donor.ListByStationLastName", myTable) ;

			Vha.Vtk.Donations.Donation.GetQuickListBy_StationId(1).WriteXmlSchema(@"c:\temp\VtkDonationListByStation.xml");
			AddHyperLink(@"c:\temp\VtkDonationListByStation.xml","Vtk.DonationsListByStation", myTable) ;

			Vha.Vtk.Donations.Donation.GetQuickListBy_StationId_BeginDate_EndDate(1, DateTime.Today, DateTime.Today).WriteXmlSchema(@"c:\temp\VtkDonationListByStationByBeginEnd.xml");
			AddHyperLink(@"c:\temp\VtkDonationListByStationByBeginEnd.xml","Vtk.DonationsListByStationByBeginEndDate", myTable) ;

			Vha.Vtk.Donations.DonorType.GetQuickList().WriteXmlSchema(@"c:\temp\VtkDonorTypeGetList.xml");
			AddHyperLink(@"c:\temp\VtkDonorTypeGetList.xml","Vtk.Donations.DonorType.GetQuickList", myTable) ;

			Vha.Vtk.Donations.DonationType.GetQuickList().WriteXmlSchema(@"c:\temp\VtkDonationTypeGetList.xml");
			AddHyperLink(@"c:\temp\VtkDonationTypeGetList.xml","Vtk.Donations.DonationType.GetQuickList", myTable) ;

			Vha.Vtk.TimeKeeping.CombinationAssignment.GetActiveQuickList(1, 1).WriteXmlSchema(@"c:\temp\VtkTimeKeepingCombinationGetActiveQuickList.xml");
			AddHyperLink(@"c:\temp\VtkTimeKeepingCombinationGetActiveQuickList.xml","Vtk.TimeKeeping.Combination.GetActiveQuickList", myTable);
*/		}

		private void AddHyperLink(string url, string text, Table myTable) 
		{
			TableCell tc = new TableCell();
			TableRow tr = new TableRow();
			tr.Cells.Add(tc);
			myTable.Rows.Add(tr);

			HyperLink hl = new HyperLink();
			hl.NavigateUrl=url;
			hl.Text=text;
			//Page.Controls.Add(hl);
			tc.Controls.Add(hl);
		}

		private void Page_Init(object sender, EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
		}

		#region Web Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
