using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using VTK.RptCR;
using CrystalDecisions.CrystalReports.Engine;
using CrystalDecisions.Shared;
using Vha.Vtk.WebControlLibrary;
using VTK.Utility;
using System.Text;

namespace VTK.Volunteer
{
	/// <summary>
	/// Summary description for ViewVolunteer.
	/// </summary>
	public class ViewVolunteer : System.Web.UI.Page
	{
		protected Vha.Vtk.WebControlLibrary.VtkPageHeader VtkPageHeader1;
		protected System.Web.UI.WebControls.Button PrintButton;
		protected System.Web.UI.WebControls.RadioButtonList PrintFormatList;
		protected System.Web.UI.WebControls.Label NameLabel;
		protected System.Web.UI.WebControls.Panel ChooserPanel;
		protected System.Web.UI.WebControls.Panel EditPanel;
		protected System.Web.UI.WebControls.Label ErrorMessage;
		protected VTK.Volunteer.VolunteerChooserControl VolunteerChooserControl1;
	
		public ViewVolunteer()
		{
			Page.Init += new System.EventHandler(Page_Init);
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			try
			{
				if (VtkPageHeader1.IsDivSelected("View Volunteer"))
				{
					if (!Page.IsPostBack)
					{
					} 
					//save the stationId on the form
					Page.RegisterHiddenField("StationId", VtkPageHeader1.DivSelectedId.ToString()) ;
				}
				else
				{ Response.Redirect("/Vtk/Welcome.aspx?" + VtkPageHeader.GetURLParameterString()+"=" + VtkPageHeader1.DivSelectedId) ;}
			}
			catch (Exception err) 
			{
				VtkUtility.ErrMsgAdd(ErrorMessage,err.Message);
			}
		}

		public class UIReportParams : VTK.Utility.UIReportParams 
		{
			public int AT_InstitutionId;
			public int AT_VolunteerId;

			public UIReportParams() 
			{
				AT_InstitutionId=0;
				AT_VolunteerId=0;
			}
		}

		private void Page_Init(object sender, EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
		}

		override protected bool OnBubbleEvent(object Sender, EventArgs e) 
		{
			bool bubbleValue = false ;
			if (VolunteerChooserControl1.VolunteerChooserSuccess)
			{
				ViewState["volId"] = VolunteerChooserControl1.VolunteerChooserId.ToString() ;
				ViewState["volName"] = VolunteerChooserControl1.VolunteerChooserName.ToString() ;
				VolunteerChooserControl1.BubbleEventClear() ;
				// fill the name into the text box
				NameLabel.Text = ViewState["volName"].ToString();
				//turn off chooser
				ChooserPanel.Visible = false ;
				EditPanel.Visible = true ;
				bubbleValue = true ;
			}
			return bubbleValue ;
		}

		#region Web Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.PrintButton.Click += new System.EventHandler(this.PrintButton_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void PrintButton_Click(object sender, System.EventArgs e)
		{
			//run report
			UIReportParams rp = new UIReportParams();
			// selected Institution
			rp.AT_InstitutionId = VtkPageHeader1.DivSelectedId ;
			// selected volunteer
			rp.AT_VolunteerId = Convert.ToInt32(ViewState["volId"]);
			// report type
			rp.ReportType=UIReportType.MasterRecordDisplayPrint;
			// report format
			rp.ReportFormat=RptUtility.GetUIReportFormat(PrintFormatList.SelectedItem.Value);

			// Put UIParams into Context
			Context.Items["ReportParams"]=rp;
			// transfer
			if (rp.ReportFormat==UIReportFormat.Web) 
			{
				Server.Transfer(RptUtility.GetCrystalWebTransferString(rp.ReportType, VtkPageHeader1, Request.ApplicationPath));
			} 
			else 
			{
				Server.Transfer("../RptCR/CrystalExport.aspx");
			}
		
		}

	}
}
