using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Text.RegularExpressions;
using System.Text;

using TimeKeeping = Vha.Vtk.TimeKeeping;
using Vha.Vtk.Common;
using Vha.Vtk.Kernel.Common;
using VTK.Utility;
using Vha.Vtk.WebControlLibrary;

namespace VTK.Volunteer
{
	/// <summary>
	/// Summary description for VolunteerNewEdit.
	/// </summary>
	public class VolunteerNewEdit : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Button PostButton;
		protected System.Web.UI.WebControls.RadioButtonList SexList;
		protected System.Web.UI.WebControls.CheckBox PseudoCheckBox;
		protected System.Web.UI.WebControls.TextBox NickNameText;
		protected System.Web.UI.WebControls.TextBox MiddleNameText;
		protected System.Web.UI.WebControls.TextBox FirstNameText;
		protected System.Web.UI.WebControls.TextBox LastNameText;
		protected System.Web.UI.WebControls.Label ConfirmationMessage;
		protected System.Web.UI.WebControls.Label ErrorMessage;
		protected System.Web.UI.WebControls.TextBox PhoneText;
		protected System.Web.UI.WebControls.TextBox Phone1Text;
		protected System.Web.UI.WebControls.TextBox Phone2Text;
		protected System.Web.UI.WebControls.TextBox EMailText;
		protected Vha.Vtk.WebControlLibrary.VtkCompositeDate DateOfBirthDate;
		protected System.Web.UI.WebControls.TextBox ZipText;
		protected System.Web.UI.WebControls.TextBox Address1Text;
		protected System.Web.UI.WebControls.TextBox Address2Text;
		protected System.Web.UI.WebControls.TextBox CityText;
		protected System.Web.UI.WebControls.DropDownList StateList;
		protected Vha.Vtk.WebControlLibrary.VtkCompositeDate EntryDate;
		protected System.Web.UI.WebControls.Label ContactLabel1;
		protected System.Web.UI.WebControls.Label ContactLabel2;
		protected System.Web.UI.WebControls.Button NewButton;
		protected System.Web.UI.WebControls.DropDownList ContactList;
		protected System.Web.UI.WebControls.Panel ContactPanel;
		protected System.Web.UI.WebControls.TextBox SSNText;
		protected System.Web.UI.WebControls.CheckBox VAEmployeeCheck;
		protected System.Web.UI.WebControls.DropDownList LanguageList;
		protected Vha.Vtk.WebControlLibrary.VtkPageHeader VtkPageHeader1;
	
		public VolunteerNewEdit()
		{
			Page.Init += new System.EventHandler(Page_Init);
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			try
			{
				if (VtkPageHeader1.IsDivSelected("Add Volunteer"))
				{
					if (!Page.IsPostBack)
					{
						string ssn = string.Empty ;
						//set year list
						DateOfBirthDate.YearListBegin = 1890 ;
						DateOfBirthDate.YearListEnd = DateTime.Now.Year ;
						DateOfBirthDate.InitializeControl() ;
						EntryDate.YearListBegin = 2000 ;
						EntryDate.YearListEnd = DateTime.Now.Year ;
						EntryDate.InitializeControl() ;
						//set entry date to today
						EntryDate.Date = DateTime.Today.Date ;

						//populate state list
						DataSet dsst = Vha.Vtk.Kernel.Data.SystemTables.State.GetQuickList() ;
						DataTable dtst = dsst.Tables["StateList"] ;
						dtst.DefaultView.Sort = "Abbreviation ASC" ;

						// insert a new row for the "not selected" item
						DataRow stdr = dtst.NewRow() ;
						stdr["Id"]=int.MinValue;
						stdr["Abbreviation"]="--";
						dtst.Rows.InsertAt(stdr,0);

						StateList.DataTextField = "Abbreviation" ;
						StateList.DataValueField = "Id" ;
						StateList.DataSource = dtst ;
						StateList.DataBind() ;
						dsst.Dispose() ;
						dtst.Dispose() ;
						
						//build language list
						DataSet dsL = Vha.Vtk.Kernel.Data.SystemTables.Language.GetQuickList() ;
						DataTable dtL = dsL.Tables["LanguageList"] ;
						LanguageList.DataTextField = "LanguageName" ;
						LanguageList.DataValueField = "ID" ;
						LanguageList.DataSource = dtL ;
						LanguageList.DataBind() ;
						dsL.Dispose() ;
						dtL.Dispose() ;

						//check for input parameter, these came from VolunteerChooserNew, existing volunteer
						if (Page.Request.QueryString["volId"] != string.Empty)
						{
							//save in view state
							ViewState["volId"] = Page.Request.QueryString["volId"].ToString() ;
							ViewState["volName"] = Page.Request.QueryString["volName"].ToString() ;

							//create handle
							int volId = Convert.ToInt32(ViewState["volId"]) ;
							Vha.Vtk.TimeKeeping.Volunteer volhdl = new Vha.Vtk.TimeKeeping.Volunteer(volId, VtkUtility.GetAppCon()) ;
							//save version and id
							ViewState["version"] = volhdl.Version.ToString() ;
							//get field values
							LastNameText.Text = volhdl.LastName.ToString() ;
							FirstNameText.Text = volhdl.FirstName.ToString() ;
							MiddleNameText.Text = volhdl.MiddleName.ToString() ;
							NickNameText.Text = volhdl.NickName.ToString() ;
							SSNText.Text = volhdl.SocialSecurityNumber.ToString() ;
							DateOfBirthDate.Date = volhdl.DateOfBirth ;
							VAEmployeeCheck.Checked = volhdl.IsVAEmployee ;
							VtkUtility.SetSelectedSingle(LanguageList.Items, volhdl.PreferredLanguageForLoginId.ToString()) ;
							if (volhdl.IsPseudoSSN)
							{ PseudoCheckBox.Checked = true ;}
							else
							{ PseudoCheckBox.Checked = false ;}
							if (volhdl.Sex == "M")
							{ SexList.SelectedIndex = 0 ;}
							if (volhdl.Sex == "F")
							{ SexList.SelectedIndex = 1 ;}

							volhdl.Dispose() ;
							GetContactList(volId) ;
							DisableFields(true);
						}
						else
						{
							//volunteer is new
							ViewState["volId"] = string.Empty ;
							//contains flag, new button was used, true because it is a new record
							ViewState["NewButton"] = "true" ;
							//check for input parameter, these came from VolunteerChooserNew, new volunteer
							if (Page.Request.QueryString["volName"].ToString() != string.Empty)
							{ LastNameText.Text = Page.Request.QueryString["volName"].ToString() ;}
							if (Page.Request.QueryString["volSSN"].ToString() != string.Empty)
							{
								SSNText.Text = Page.Request.QueryString["volSSN"].ToString() ;
							}								
						}
					}
					//save the stationId on the form
					Page.RegisterHiddenField("StationId", VtkPageHeader1.DivSelectedId.ToString()) ;
				}
				else
				{ Response.Redirect("/Vtk/Welcome.aspx?" + VtkPageHeader.GetURLParameterString()+"=" + VtkPageHeader1.DivSelectedId) ;}
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Volunteer Record: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Volunteer Record: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Volunteer Record: " + err.Message) ;}
		}

		//added by Sachy 05/03/2004
		//This was added to disable all the fields of Add New Volunteer page
		//because this volunteer already exist in the sytstem and new site is 
		//just trying to create a profile for this volunteer at new site.
		//So no need to allow them to change then Volunteer's Master record.
		private void DisableFields(bool disableAll)
		{

			LastNameText.Enabled = !disableAll;
			FirstNameText.Enabled = !disableAll;
			MiddleNameText.Enabled = !disableAll;
			NickNameText.Enabled = !disableAll;
			DateOfBirthDate.Enabled = !disableAll;
			VAEmployeeCheck.Enabled = !disableAll;
			LanguageList.Enabled = !disableAll;
			PseudoCheckBox.Enabled = !disableAll;
			SexList.Enabled = !disableAll;
		}

		private void GetContactList(int volId)
		{
			try
			{
				//populate list of contacts, get dataset
				DataSet ds = Vha.Vtk.TimeKeeping.ContactInformation.GetQuickList(volId, VtkUtility.GetAppCon()) ;
				DataTable dt = ds.Tables["ContactInformationList"] ;
				//check for multiple contact information
				if (dt.Rows.Count > 0)
				{
					//define columns in list box
					ContactList.DataTextField = "StreetAddress1" ;
					ContactList.DataValueField = "Id" ;
					//bind list box to DataTable and cleanup
					ContactList.DataSource = dt ;
					ContactList.DataBind() ;

					//contains flag, new button was used
					ViewState["NewButton"] = "false" ;
					//make list and button visible, panel invisible
					ContactLabel1.Visible = true ;
					ContactLabel2.Visible = true ;
					ContactList.Visible = true ;
					NewButton.Visible = true ;
					ContactPanel.Visible = false ;
				}
				else
				{
					//contains flag, new button was used, set to true because contact information will be new
					ViewState["NewButton"] = "true" ;
					ContactLabel1.Visible = false ;
					ContactLabel2.Visible = false ;
					ContactList.Visible = false ;
					NewButton.Visible = false ;
					ContactPanel.Visible = true ;
				}
				ds.Dispose() ;
				dt.Dispose() ;
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Contact List: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Contact List: " + transErr.Message + transErr.TransactionType) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Contact List: " + err.Message) ;}
		}

		private string MissingFields()
		{
			string fields = string.Empty ;
			if (LastNameText.Text == string.Empty)
			{ fields = "Last Name, " ;}
			if (FirstNameText.Text == string.Empty)
			{ fields = fields + "First Name, " ;}
			if (SSNText.Text == string.Empty)
			{ fields = fields + "Social Security Number, " ;}
			if (DateOfBirthDate.Date == DateTime.MinValue)
			{ fields = fields + "Date Of Birth, " ;}
			if (SexList.SelectedIndex < 0)
			{ fields = fields + "Sex, " ;}
			if (EntryDate.Date == DateTime.MinValue)
			{ fields = fields + "Entry Date, " ;}
			//check if ContactList has any value
			if (ContactList.SelectedIndex < 0)
			{
				if (Address1Text.Text == string.Empty)
				{ fields = fields + "Street Address #1, " ;}
				if (CityText.Text == string.Empty)
				{ fields = fields + "City, " ;}
				if (StateList.SelectedIndex < 0)
				{ fields = fields + "State, " ;}
				if (ZipText.Text == string.Empty)
				{ fields = fields + "Zip, " ;}
			}
			return fields ;
		}

		private void PostButton_Click(object sender, System.EventArgs e)
		{
			//define handles
			Vha.Vtk.TimeKeeping.Volunteer volhdl = null ;
			Vha.Vtk.TimeKeeping.ContactInformation conhdl = null ;
			Vha.Vtk.TimeKeeping.StationProfile prohdl = null ;
			int volId = 0 ;
			int conId = 0 ;
			string volName = string.Empty ;
			bool versionOk = true ;

			string missingdata = MissingFields() ;
			if (missingdata != string.Empty)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "The following fields are Required: " + missingdata) ;}
			else
			{
				try
				{
					//check if new or existing record
					if (ViewState["volId"].ToString() != string.Empty)
					{
						volId = Convert.ToInt32(ViewState["volId"].ToString()) ;
						volhdl = new Vha.Vtk.TimeKeeping.Volunteer(volId, VtkUtility.GetAppCon()) ;
						//check version
						if (ViewState["version"].ToString() != volhdl.Version.ToString())
						{
							VtkUtility.ErrMsgAdd(ErrorMessage, "Current Volunteer record has changed while you were editing, Please press EXIT and start over. ") ;
							versionOk = false ;
						}
					}
					else
					{
						//new record
						volhdl = Vha.Vtk.TimeKeeping.Volunteer.AddRecord() ;
					}
					if (versionOk)
					{
						//post values
						string ssn = SSNText.Text ;
						//if ssn contains dashes, remove
						if (Regex.IsMatch(ssn, @"^\d{3}-\d{2}-\d{4}"))
						{ ssn = ssn.Substring(0,3) + ssn.Substring(4,2) + ssn.Substring(7,4) ;}
						volhdl.SocialSecurityNumber = ssn ;
						volhdl.LastName = LastNameText.Text.ToString().Trim() ;
						volhdl.FirstName = FirstNameText.Text.ToString().Trim() ;
						volhdl.MiddleName = MiddleNameText.Text.ToString() ;
						volhdl.NickName = NickNameText.Text.ToString() ;
						volhdl.DateOfBirth = DateOfBirthDate.Date ;
						volhdl.IsVAEmployee = VAEmployeeCheck.Checked ;
						volhdl.PreferredLanguageForLoginId = Convert.ToInt32(LanguageList.SelectedItem.Value) ;
						if (PseudoCheckBox.Checked == true)
						{  volhdl.IsPseudoSSN = true ;}
						else
						{ volhdl.IsPseudoSSN = false ;}
						if (SexList.SelectedIndex == 0)
						{ volhdl.Sex = "M" ;}
						if (SexList.SelectedIndex == 1)
						{ volhdl.Sex = "F" ;}

						//check new button was used
						if (Convert.ToBoolean(ViewState["NewButton"]))
						{
							//new record
							conhdl = Vha.Vtk.TimeKeeping.ContactInformation.AddRecord() ;
							//save current fields
							conhdl.StreetAddress1 = Address1Text.Text ;
							conhdl.StreetAddress2 = Address2Text.Text ;
							conhdl.City = CityText.Text ;
							conhdl.ZipCode = ZipText.Text ;
							conhdl.Telephone = PhoneText.Text ;
							conhdl.AlternateTelephone = Phone1Text.Text ;
							conhdl.AlternateTelephone2 = Phone2Text.Text ;
							conhdl.EMailAddress = EMailText.Text ;
							if (StateList.SelectedIndex > -1)
							{ conhdl.StateId = Convert.ToInt32(StateList.SelectedItem.Value) ;}
						}
						else
						{
							//contact already exist and was selected
							conId = Convert.ToInt32(ContactList.SelectedItem.Value) ;
							conhdl = new TimeKeeping.ContactInformation(conId) ;
						}
						
						//create a station profile and file required fields
						prohdl = Vha.Vtk.TimeKeeping.StationProfile.AddRecord() ;
						prohdl.EntryDate = EntryDate.Date ;
						prohdl.StationId = VtkPageHeader1.DivSelectedId ;
						prohdl.EligibleForMeals = 1 ;

						//save all 3 objects and returns the volunteer object
						ReturnStatus ret = null ;
						volId = Vha.Vtk.TimeKeeping.Volunteer.AddRecord(volhdl, conhdl, prohdl, out ret) ;

						//get volId & get values from volunteer object
						volhdl = new Vha.Vtk.TimeKeeping.Volunteer(volId, VtkUtility.GetAppCon()) ;

						//need volunteer name and id for navigation after posting
						volName = volhdl.LowercaseNameForDisplay ;

						//clean up
						volhdl.Dispose() ;
						conhdl.Dispose() ;
						prohdl.Dispose() ;

						//navigate to next of kin edit page
						StringBuilder sb = new StringBuilder("VolunteerComboEdit.aspx?") ;
						//add division
						sb.Append(VtkPageHeader.GetURLParameterString()) ;
						sb.Append("=") ;
						sb.Append(VtkPageHeader1.DivSelectedId.ToString()) ;
						//add volunteer id
						sb.Append("&volId=") ;
						sb.Append(volId.ToString()) ;
						//add volunteer name
						sb.Append("&volName=") ;
						sb.Append(volName.ToString()) ;
						//add flag that volunteer is new
						sb.Append("&isNewVol=true") ;
						Response.Redirect(sb.ToString()) ;
					}
				}
				catch (VhaValidationException valErr)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error posting the Volunteer Record: " + valErr.Message) ;}
				catch (VhaTransactionException transErr)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error posting the Volunteer Record: " + transErr.Message) ;}
				catch (Exception err)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error posting the Volunteer Record: " + err.Message) ;}
			}
		}

		private void NewButton_Click(object sender, System.EventArgs e)
		{
			//make list invisible, panel visible
			ViewState["NewButton"] = "true" ;
			ContactLabel1.Visible = false ;
			ContactLabel2.Visible = false ;
			ContactList.Visible = false ;
			NewButton.Visible = false ;
			ContactPanel.Visible = true ;		
		}

		private void ExitButton_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("../Index.aspx?" + VtkPageHeader.GetURLParameterString() + "=" + VtkPageHeader1.DivSelectedId.ToString());
		}

		private void Page_Init(object sender, EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
		}

		#region Web Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
					private void InitializeComponent()
					{    
						this.NewButton.Click += new System.EventHandler(this.NewButton_Click);
						this.PostButton.Click += new System.EventHandler(this.PostButton_Click);
						this.Load += new System.EventHandler(this.Page_Load);

					}
		#endregion

	}
}
