<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
								xmlns:msxsl="urn:schemas-microsoft-com:xslt" 
								xmlns:user="http://userns" 
								xmlns:security="urn:security"
								version="1.0" 
								exclude-result-prefixes="#default security msxsl user">
								
	<xsl:output omit-xml-declaration="no" 
							version="1.0"
						  method="xml" 
						  indent="yes"/>						  
	<xsl:param name="StationId"/>	
	<xsl:template match="/doc">
		<doc>
			<xsl:apply-templates select="MenuSection"/>
			<xsl:apply-templates select="MenuItem"/>
		</doc>
	</xsl:template>
	<xsl:template match="MenuSection">
		<xsl:if test="@SecureArea='false' or (@SecureArea='true' and security:IsInRole(@DisplayText))">
			<MenuSection DisplayText="{@DisplayText}" Title="{@Title}">
				<xsl:if test="@URL">
					<xsl:attribute name="URL">
						<xsl:value-of select="@URL"/>
					</xsl:attribute>
				</xsl:if>
				<xsl:apply-templates select="MenuSection"/>
				<xsl:apply-templates select="MenuItem"/>
				<!--<xsl:apply-templates select="MenuItem"/>-->
			</MenuSection>	
		</xsl:if>	
	</xsl:template>
	
	<xsl:template match="MenuItem">
		<xsl:if test="@SecureArea='false' or (@SecureArea='true' and security:IsInRole(@DisplayText))">
			<MenuItem DisplayText="{@DisplayText}" Title="{@Title}">
				<xsl:if test="@URL">
					<xsl:attribute name="URL">
						<xsl:value-of select="@URL"/>
					</xsl:attribute>
				</xsl:if>
				<xsl:if test="@Image">
					<xsl:attribute name="Image">
						images/menu/<xsl:value-of select="@Image"/>
					</xsl:attribute>
				</xsl:if>
			</MenuItem>
		</xsl:if>
	</xsl:template>
</xsl:stylesheet>