using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using Vha.Vss.Utility;
using Vha.Vtk.Kernel.Common;
using System.Xml;
using System.Xml.XPath;
using System.Xml.Xsl;

namespace VTK
{
	/// <summary>
	/// Summary description for _default.
	/// </summary>
	public class _default : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Panel UnauthorizedPanel;
		protected System.Web.UI.WebControls.Panel AuthorizedPanel;
		protected System.Web.UI.WebControls.Label msg;		
		protected Vha.Vtk.WebControlLibrary.VtkPageHeader VtkPageHeader1;
		protected XmlDocument XmlDivisionList;

		private void Page_Load(object sender, System.EventArgs e)
		{
			string UnauthorizedMessage = "You are not authorized to access this application. <BR>Please contact your local Administrator for access.";
			string BrowserIncompatable = "You must be running Internet Explorer 5.5 or better to use the VSS Web Application. Please contact your local IRM for upgrade information.";
			Page.Trace.Warn("Browser Version", Page.Request.Browser.MajorVersion + "." + Page.Request.Browser.MinorVersion);
			
			string BrowserType = Page.Request.Browser.Browser;
			int MajorVersion = Page.Request.Browser.MajorVersion;
			double MinorVersion = Page.Request.Browser.MinorVersion;

			bool BrowserTypeValid = false;
			bool MajorVersionValid = false;
			bool MinorVersionValid = false;
			
			BrowserTypeValid		= BrowserType == "IE"? true:false;
			MajorVersionValid		= MajorVersion >= 5 ? true:false;
			MinorVersionValid		= MajorVersionValid ? true: ((MajorVersion == 5 && MinorVersion >= 5)?true:false);

			
			XmlDivisionList = new XmlDocument();
			String Auth_User = Page.Request.ServerVariables.Get("AUTH_USER");
			XmlDivisionList = ApplicationConnection.GetXmlDivisionList(Auth_User);

			if(XmlDivisionList.OuterXml == "" || XmlDivisionList == null)
			{
				msg.Text = UnauthorizedMessage;
				UnauthorizedPanel.Visible = true;
				AuthorizedPanel.Visible = false;
			}
			else
			{
				if(BrowserTypeValid && MajorVersionValid && MinorVersionValid)
				{
					UnauthorizedPanel.Visible = false;
					AuthorizedPanel.Visible = true;
				}
				else
				{
					msg.Text = BrowserIncompatable;
					UnauthorizedPanel.Visible = true;
					AuthorizedPanel.Visible = false;
				}				
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
