using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using Vha.Vtk.WebControlLibrary;
using VtkUser.Utility;
using Vha.Vtk.TimeKeeping;
using Vha.Vtk.Common;
using System.Resources;
using System.Threading;
using System.Globalization;
using System.Reflection;
using System.Xml;
using System.Xml.XPath;
using Vha.Vss.Utility;

namespace VtkUser
{
	/// <summary>
	/// Summary description for MealTicket.
	/// </summary>
	public class MealTicket : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Literal MetaRefresh;
		protected System.Web.UI.WebControls.Label YouAreEligible;
		protected System.Web.UI.WebControls.Button YesButton;
		protected System.Web.UI.WebControls.Label ErrorMessage;
		protected Vha.Vtk.WebControlLibrary.VtkUserPageHeader VhaVtkUserPageHeader1;
		protected System.Web.UI.WebControls.Button NoButton;
		protected System.Web.UI.WebControls.Label HeadingLabel;
		protected System.Web.UI.HtmlControls.HtmlGenericControl myBody;
		protected System.Web.UI.WebControls.CustomValidator CustomValidator1;
		protected System.Web.UI.WebControls.TextBox txtBox;
		protected System.Web.UI.HtmlControls.HtmlInputHidden requestSubmitted;

		string STATIONID=VtkUserPageHeader.GetURLParameterString();
	
		public MealTicket()
		{
			Page.Init += new System.EventHandler(Page_Init);
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack) 
			{
				YesButton.Attributes.Add("OnClick", "this.style.backgroundColor='red';this.style.color='black'");
				NoButton.Attributes.Add("OnClick", "this.style.backgroundColor='red';this.style.color='black'");
				string debug = "";

				//Sachy - 07/30/2003 Code change to fix Multiple submits.
				requestSubmitted.Value = "false";
				txtBox.Width = 0;

				try 
				{
					//this needs a body tag or something.
					VhaVtkUserPageHeader1.VerifyStation();
					Thread.CurrentThread.CurrentCulture = 
						CultureInfo.CreateSpecificCulture(VhaVtkUserPageHeader1.CurrentLanguage);
					Thread.CurrentThread.CurrentUICulture = Thread.CurrentThread.CurrentCulture;
				} 
				catch (Exception err)
				{
					VtkUtility.ErrMsgAdd(ErrorMessage, err.Message);
				} 
				finally 
				{
					try
					{
						DateTime clientTime = Convert.ToDateTime(Context.Items["Time"].ToString()) ;
						int hours = Convert.ToInt32(Context.Items["Hours"].ToString()) ;
						int siteId = VhaVtkUserPageHeader1.CurrentStationId ;
						int volId = Convert.ToInt32(Page.User.Identity.Name) ;
						
						//************    Testing BL Logic  **************
						string dayOfWeek = clientTime.DayOfWeek.ToString();
						int numberOfMeals = 0 ;
						decimal price = 0;
						string sprice = "";
						string volunteerName = String.Empty;
						TimeSpan ti = clientTime.TimeOfDay;
						int hrs = ti.Hours;
						int min = ti.Minutes;
						Page.Trace.Warn("StationId", VhaVtkUserPageHeader1.CurrentStationId.ToString());
						Page.Trace.Warn("Clients Time", clientTime.ToString());
						Page.Trace.Warn("Hours Worked", hours.ToString());
						Page.Trace.Warn("Day of Week", dayOfWeek);
						Page.Trace.Warn("Time", ti.ToString());
						Page.Trace.Warn("24 HR Time", Convert.ToString((hrs*100)+min));

						//************    Testing BL Logic  **************
						//check if volunteer already printed ticket
						
						NameObjectCollection mealRec = new NameObjectCollection();
						DateTime lastTime;
						NameObjectCollection mealList = Vha.Vtk.MealTickets.MealsProvided.GetMealTicketDRList(clientTime.Date, siteId, numberOfMeals, volId) ;
						if (mealList.Count > 0)
						{
							mealRec = (NameObjectCollection)mealList.Get(0);
							lastTime = (DateTime)mealRec.Get("Column2");
							if (lastTime != System.DateTime.MinValue)
							{
								//volunteer already printed ticket, goto end
								VhaVtkUserPageHeader1.ServerTransfer("Thankyou.aspx");
							}								
						}

						if(!Volunteer.IsMealTicketAppropriate(siteId, volId, clientTime, hours, 
							out price, out volunteerName, out numberOfMeals, VtkUtility.GetAppCon(), out debug))
						{
							//YouAreEligible.Text="";
							//YesButton.Enabled=false;
							VhaVtkUserPageHeader1.ServerTransfer("Thankyou.aspx");
						}
						else
						{
							sprice = price.ToString("###.##");

							LanguageResourcesLoad(numberOfMeals);

							Page.RegisterHiddenField("VolunteerName", volunteerName);
//							Page.RegisterHiddenField("Price", price.ToString());
							Page.RegisterHiddenField("Price", sprice);
							//Page.RegisterHiddenField("DateTime", clientTime.ToShortDateString());
							//Page.RegisterHiddenField("DateTime", Convert.ToDateTime(Context.Items["Time"]).ToString("MM/dd/yyyy"));
							Page.RegisterHiddenField("DateTime", Context.Items["Time"].ToString());
							Page.RegisterHiddenField("NumberOfMeals", numberOfMeals.ToString()) ;
							Page.RegisterHiddenField("VolunteerId", Page.User.Identity.Name) ;
							Page.RegisterHiddenField("SiteId", VhaVtkUserPageHeader1.CurrentStationId.ToString()) ;
							
							YesButton.Enabled = true;
							myBody.Attributes.Add("onLoad","document.MealTicket.YesButton.focus();");
						
							//************    Testing BL Logic  **************
							Page.Trace.Warn("Number of Meals", numberOfMeals.ToString());

						}
						Page.Trace.Warn("DEBUG", debug) ;

					} 
					catch (Exception err)
					{
						VtkUtility.ErrMsgAdd(ErrorMessage+ "<BR>" + debug, err.Message);
					} 
				}

			} 
		else 
			{
				string language=VhaVtkUserPageHeader1.CurrentLanguage;
				Thread.CurrentThread.CurrentCulture = CultureInfo.CreateSpecificCulture(language);
				Thread.CurrentThread.CurrentUICulture = Thread.CurrentThread.CurrentCulture;
			}
			try
			{
				//get the timeout value from web.config, it in in Path
				AppConfiguration VssConfig = new AppConfiguration(Server.MapPath("") + @"\web.config") ;
				VssConfig.Load() ;
				XmlNode ApplicationNode = VssConfig.GetAppConfigData("VssConfiguration", string.Empty) ;
				//save the timeout value and the stationId on form so it can be retrieve in HTML code
				string timeOut = ApplicationNode.Attributes.GetNamedItem("TimeOut").Value;
				string stationId = VhaVtkUserPageHeader1.CurrentStationId.ToString();
				MetaRefresh.Text = "<meta http-equiv=\"refresh\" content=\"" + timeOut + "; url=ThankYou.aspx?StationId=" + stationId + "\">";
			} 
			catch (Exception err) 
			{
				VtkUtility.ErrMsgAdd(ErrorMessage, err.Message);
			}
		}

		private void LanguageResourcesLoad(int nMeal) 
		{
			//nMeal = number of meals
			Assembly a = Assembly.Load("VtkUser");
			ResourceManager rm = new ResourceManager("VtkUser.strings", a);
			HeadingLabel.Text=rm.GetString("mealticketHeader");
			YesButton.Text=rm.GetString("txtYes");
			NoButton.Text=rm.GetString("txtNo");
			if (nMeal == 2)
			{ YouAreEligible.Text=rm.GetString("mealticketYouAreEligibleII");}
			else
			{ YouAreEligible.Text=rm.GetString("mealticketYouAreEligible");}
		}

		private void Page_Init(object sender, EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
		}

		#region Web Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.VhaVtkUserPageHeader1.Click += new System.EventHandler(this.PageHeader_Click);
			this.YesButton.Click += new System.EventHandler(this.YesButton_Click);
			this.NoButton.Click += new System.EventHandler(this.NoButton_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void YesButton_Click(object sender, System.EventArgs e)
		{

			//check site parameters, see if site is supporting meal list or meal tickets
			int siteId = Convert.ToInt32(Request.Form["SiteId"].ToString()) ;
			Vha.Vtk.Common.StationParameters sitehdl = new Vha.Vtk.Common.StationParameters(siteId, VtkUtility.GetAppCon()) ;
			if (sitehdl.MealAuthorization == "T")
			{
				//meal ticket, navigate to print page
				Response.Redirect("PrintMealTicket.aspx?Time=" + Request.Form["DateTime"] + "&Name=" + Request.Form["VolunteerName"] + "&Price=" + Request.Form["Price"]
					+ "&NumberOfMeals=" + Request.Form["NumberOfMeals"] + "&VolId=" + Request.Form["VolunteerId"] 
					+ "&SiteId=" + Request.Form["SiteId"]);
			}
			else
			{
				//this is a meal list, just file the data
				try
				{
					//get values save in MealTick.aspx
					DateTime clientTime = Convert.ToDateTime(Request.Form["DateTime"].ToString()) ;
					Vha.Vtk.MealTickets.MealsProvided mthdl = Vha.Vtk.MealTickets.MealsProvided.AddRecord(VtkUtility.GetAppCon()) ;
					mthdl.DateOfMeal = clientTime.Date ;
					mthdl.InstitutionId = siteId ;
					mthdl.VolunteerId = Convert.ToInt32(Request.Form["VolunteerId"].ToString()) ;
					mthdl.IsReprinted = false ;
					mthdl.NumberOfMeals = Convert.ToInt32(Request.Form["NumberOfMeals"].ToString()) ;
					mthdl.HowAdded = "A" ;
					mthdl.TimeLastPrinted = DateTime.Now ;
					mthdl.Save() ;
					mthdl.Dispose() ;
				}
				catch (Exception err)
				{
					VtkUtility.ErrMsgAdd(ErrorMessage, err.Message);
				}
				//navigate to thankyou page
				VhaVtkUserPageHeader1.ServerTransfer("Thankyou.aspx"); 
			}
		}

		private void NoButton_Click(object sender, System.EventArgs e)
		{
			 VhaVtkUserPageHeader1.ServerTransfer("Thankyou.aspx");
			//Server.Transfer("Thankyou.aspx?"+STATIONID+"="+Request.Params[STATIONID]);
		}

		private void PageHeader_Click(object sender, System.EventArgs e)
		{

		}
	}
}
