using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using System.Web.Security;
using Vha.Vtk.WebControlLibrary;
using System.Resources;
using System.Threading;
using System.Globalization;
using System.Reflection;

namespace VtkUser
{
	/// <summary>
	/// Summary description for Thankyou.
	/// </summary>
	public class Thankyou : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label ErrorMessage;
		protected System.Web.UI.WebControls.Label HeadingLabel;
		protected System.Web.UI.WebControls.Label LoggedOffLabel;
		protected System.Web.UI.WebControls.Button LogOnButton;
		protected System.Web.UI.HtmlControls.HtmlGenericControl myBody;

		string STATIONID=VtkUserPageHeader.GetURLParameterString();
		const string INFOLANGUAGE="VhaPageHeaderLanguage";

		public Thankyou()
		{
			Page.Init += new System.EventHandler(Page_Init);
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			string language;
			if (Context.Items[INFOLANGUAGE]!=null) 
			{
				language=(string) Context.Items[INFOLANGUAGE];
			} 
			else 
			{
				//TODO: use the site default
				language="en-US";
			}
			Thread.CurrentThread.CurrentCulture = CultureInfo.CreateSpecificCulture(language);
			Thread.CurrentThread.CurrentUICulture = Thread.CurrentThread.CurrentCulture;

			if (!IsPostBack) 
			{
				LanguageResourcesLoad();
				myBody.Attributes.Add("onLoad","document.Thankyou.LogOnButton.focus();");
			}
			FormsAuthentication.SignOut();
		}

		private void LanguageResourcesLoad() 
		{
			Assembly a = Assembly.Load("VtkUser");
			ResourceManager rm = new ResourceManager("VtkUser.strings", a);
			HeadingLabel.Text=rm.GetString("thankyouHeader");
			LoggedOffLabel.Text=rm.GetString("thankyouLogOffConfirm");
			LogOnButton.Text=rm.GetString("txtLogin");
		}

		private void Page_Init(object sender, EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
		}

		#region Web Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.LogOnButton.Click += new System.EventHandler(this.Button1_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void Button1_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("index.aspx?"+STATIONID+"="+Request.Params[STATIONID]);
		}
	}
}
